﻿#target bridge
if (BridgeTalk.appName == 'bridge')
/*
Terms and Conditions of Use
Copyright © 2015 Visual Resources Association
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This script is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. http://www.gnu.org/licenses/ 

Disclaimer of Warranty
THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM “AS IS” WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
Limitation of Liability

IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
*/

{ // brace 1 open
// Basic characters used throughout the code
var codeVersion = "code version: 2015-11-10";
var plgnName = "VRA Metadata Export-Import";
var plgnVers = "version 1.0";
var appDataFwdSlash = Folder.userData;
var plgnPrefs = "/VRA_Import_Export";
var plgnSet = "/settings.txt";
//var hardDriveCheck = hardDrive;
var plgnOpt = "/Options";
var exportChoice = "folder";

//Create a menu option within Adobe Bridge
var menu = MenuElement.create( "command", "VRA Metadata Export-Import 1.0", "at the end of Tools");
menu.onSelect = function()

	{ // brace 2 open
     // Load the XMP Script library
     if( xmpLib == undefined ){
          if( Folder.fs == "Windows" ){
               var pathToXMPLib = Folder.startup.fsName + "/AdobeXMPScript.dll";
			}
          else{
               var pathToXMPLib = Folder.startup.fsName + "/AdobeXMPScript.framework";
			}
          var libfile = new File( pathToXMPLib );
          var xmpLib = new ExternalObject("lib:" + pathToXMPLib );
		}
	
	//Tool tips
	var clickInstrucTT = "Click for instructions";
        
	var imageFolderPath = "Path/directory to your folder of images.\nClick 'Browse' to set the path.";
	var imageFolderBrowse = "Locate the path to your folder of images.";
	
	var textFilePath = "Path/directory to your .txt file.\nClick 'Browse' to set the path.";
	var textFileBrowse = "Locate the path to your .txt file";
	
	var dateWhyTT = 
	"This is useful if you will be importing the metadata to Excel.\n\n" +
	"XMP Date values must use the YYYY/MM/DD format.  Adding a '_' character at the beginning of the Date will prevent Excel from automatically changing it to a format XMP cannot understand.\n\n" +
	"The '_' character will be removed when you import the data back into the image file(s)."
			   
	var lineFeedWhyTT = 
	"This is useful if you will be importing the metadata to Excel.\n\n" +
	"When selected, line breaks (line feed and carriage return) will be replaced by a semi-colon and a space ('; ').\n\n"+
	"When not selected, line breaks will be retained but converted to plain text place holders ('LF'), ('CR') so that they are not changed by Excel.  When the data is imported back to an image, the codes will be changed to the proper XMP encoding."	
	
	var replaceDataTT = 
	"Completely replaces any existing metadata\n" +
	"in the image file(s) with the metadata in the\n"+
    "tab-delimited import file.\n" +
	"   • Overwrites all fields except camera and\n"+
    "      software fields."
		  
	var appendDataTT = 
	"Applies the tab-delimited import metadata\n"+
    "where no metadata value or property currently\n" +
	"exists in the file.\n" +
	"   • Does not overwrite existing data.\n" +
	"   • Data will only be imported to blank fields."
	
	var createTemplateTT = 
	"Creates a text file which, when opened in Excel, contains the proper column field names for the VRA import function.\nYou can then paste your own data in the appropriate columns for import.";
	
	var IgnoreExtCbTT = 
	"When selected, metadata will be imported to all matching media with matching file names regardless of the file extension.\n" +
	"This allows you to import matching metadata to all versions of the same media file, e.g., .tif, .jpg. .png.";
	
    var createTitleTT = 
	"When selected, the Title (dc:title) will be filled with the data values from VRA  fields:\n" +
	"Work Title; Image view";
    
	var createKeywordsTT = 
	"When selected, Keywords (dc:subject) will be filled with the data values from VRA Work fields:\n" +
	"Subject; Style/Period; Culture; Work Type; Technique; Site";
	
	var createDescriptionTT = 
	"When selected, the Description/Caption (dc:description) will be filled with the data values from VRA Work fields:\n" +
	"Creator; Title, View; Date; Work Type; Materials; Measurements; Repository; Location; Work ID; Rights";
	
	var addLabelTT = 
	"When selected, each image that has metadata successfully imported will have its label set to: 'VRA metadata imported' and the label color will be changed to white.\n" +
	"Warning: Existing labels will be lost.";
    
    var useDefaultBtnTT = 
    "Click to use the default header in your custom list";
    
    // today's date
    var dateTime = new XMPDateTime(new Date()); // now
    var dateYMD = dateTime.toString().slice(0, -19)
    var un = undefined;

	var customheadersOptChoice = "manuallyChoose"
	var lastViewedHeadersPanel = "Work";
	var spot = "•";
	//var activeInd = "◆"; // ★
	var rightArrow = " ➜";
	//var check = "✓";

     // If the current file system is Windows, create directory location variables
     if (Folder.fs == 'Windows'){
		var hardDrive = "C:\\";
		var appDataPlgnSetBkSlash = Folder (File.decode (Folder.userData)).toString().split ("/").join ("\\"); // User preferences file	~\AppData\Roaming	
		}
     // If the current file system is Mac, create directory location variables
     else{
          var hardDrive = "//";
          var appDataPlgnSetBkSlash = Folder (File.decode (Folder.userData)).toString();
          while (appDataPlgnSetBkSlash.split ("/.").length > 1) var appDataPlgnSetBkSlash = appDataPlgnSetBkSlash.split ("/.").join ("/");
          while (appDataPlgnSetBkSlash.split ("./").length > 1) var appDataPlgnSetBkSlash = appDataPlgnSetBkSlash.split ("./").join ("/");
          var pathFirstChar = "/";
          if (appDataPlgnSetBkSlash.substring (0,1) == "~") var pathFirstChar = "~";
          var appDataPlgnSetBkSlash = appDataPlgnSetBkSlash.split ("~").join ("");
          while (appDataPlgnSetBkSlash.split ("//").length > 1) var appDataPlgnSetBkSlash = appDataPlgnSetBkSlash.split ("//").join ("/");
		}

    // default location for export text file
    if (Folder.fs == "Windows"){
        var desktopSaveFile = "~\\Desktop\\VRA_metadata_"+dateYMD+".txt";
        }
    else{
        var desktopSaveFile = "~/Desktop/VRA_metadata_"+dateYMD+".txt";
        }
    // desktop
    if (Folder.fs == "Windows"){
		var desktop = "~\\Desktop\\";
		}
	else{
		var desktop = "~/Desktop/";
		}
	 // preferredSize for UI objects
     if (Folder.fs == "Windows"){
	 // columns
    var colSize1 = [160,550]
    var colSize2 = [610,550]
    // navigation button indent
    var navBtnsIndentArr = ["                  ","                  ","       ",]
    var editMSml = [160,22];
    var dropdownSize1 = [160,18]
    var buttonSize1 = [22,22];
    var buttonSize1a = [22,22]
    var buttonSize2 = [30,30];
    var buttonSize3 = [80,20]
    var buttonSize5 = [130,22]
    var buttonSize7a = [150,32]
    var buttonSize8 = [180,30]
    var buttonSize9 = [210,40]
    var headerListSpacing = 1
    var headerUseBtnSpacing = 1
	}
else{
	// columns
	var colSize1 = [180,550]
	var colSize2 = [620,550]
	// navigation button indent
    var navBtnsIndentArr = ["                ","                ","     "]
    var editMSml = [180,22];
	var buttonSize1 = [34,24];
    var buttonSize1a = [46,22]
	var buttonSize2 = [60,60];
	var buttonSize3 = [100,34]
	var buttonSize5 = [130,24]
	var buttonSize7a = [170,32]
    var buttonSize8 = [200,40]
    var buttonSize9 = [240,40]
	var dropdownSize1 = [180,22]
    var headerListSpacing = 2
    var headerUseBtnSpacing = 0 // 6
	}

	var exportImageFolderOK = false;
	var exportTextFolderOK = false;
	var exportTextFileOK = false;
	
	var importImageFolderOK = false;
	var importTextFolderOK = false;
	var importTextFileOK = false;
          
     // if it doesn't already exist, create folder: C:\Users\[user name]\AppData\Roaming\VRA_Import_Export\Options
     if (Folder (appDataFwdSlash + plgnPrefs).exists == false){
          new Folder (appDataFwdSlash + plgnPrefs).create();
          //removed code here that writes 'appDataFwdSlash' to desktop if writing to appDataFwdSlash failed
		}
  
     // Namespaces
     var namespace_CC = "http://creativecommons.org/ns#"; 
     XMPMeta.registerNamespace (namespace_CC, "cc");
	 	 
     var namespace_IPTC_CORE = "http://iptc.org/std/Iptc4xmpCore/1.0/xmlns/";
     XMPMeta.registerNamespace (namespace_IPTC_CORE, "Iptc4xmpCore");
	 
     var namespace_PHOTOSHOP = "http://ns.adobe.com/photoshop/1.0/";
     XMPMeta.registerNamespace (namespace_PHOTOSHOP, "photoshop");
	 
     var namespace_VRAE = "http://www.vraweb.org/vracore/4.0/essential/";
     XMPMeta.registerNamespace (namespace_VRAE, "vrae");
	 
	 var namespace_W3 = "http://www.w3.org/XML/1998/namespace";
     XMPMeta.registerNamespace (namespace_W3, "xml");
	
    var namespace_XMP_RIGHTS = "http://ns.adobe.com/xap/1.0/rights/";
    XMPMeta.registerNamespace (namespace_XMP_RIGHTS, "xmpRights");
	
    // if it doesn't already exist, create folder 'userData/VRA_Import_Export/Options'
     if (Folder (appDataFwdSlash + plgnPrefs + plgnOpt).exists == false) new Folder (appDataFwdSlash + plgnPrefs + plgnOpt).create();
     
     // complex object for header, customHeader, namespace and path
     var headerObject = [{header:'File Name (required)', customHeader:'',type:'system', namespace:'', path:''}, {header:'File Path (optional)', customHeader:'',type:'system', namespace:'', path:''}, {header:'Work Creator', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.agent'}, {header:'Work Title', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.title'}, {header:'Work Date', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.date'}, {header:'Work Style/Period', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.stylePeriod'}, {header:'Work Culture', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.culturalContext'}, {header:'Work Work Type', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.worktype'}, {header:'Work Materials', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.material'}, {header:'Work Techniques', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.technique'}, {header:'Work Measurements', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.measurements'}, {header:'Work Repository', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.locationRepository'}, {header:'Work Site', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.locationSite'}, {header:'Site Sublocation', customHeader:'',type:'text', namespace:namespace_IPTC_CORE, path:'Location'}, {header:'Site City', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'City'}, {header:'Site Country', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'Country'}, {header:'Site Country Code', customHeader:'',type:'text', namespace:namespace_IPTC_CORE, path:'CountryCode'}, {header:'Site Province or State', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'State'}, {header:'Site GPS Latitude', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSDestLatitude'}, {header:'Site GPS Longitude', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSDestLongitude'}, {header:'Site GPS Bearing Ref', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSDestBearingRef'}, {header:'Site GPS Bearing', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSDestBearing'}, {header:'Site GPS Distance Ref', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSDestDistanceRef'}, {header:'Site GPS Distance', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSDestDistance'}, {header:'Work Creation Location', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.locationCreation'}, {header:'Work Discovery Location', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.locationDiscovery'}, {header:'Work Exhibition Location', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.locationExhibition'}, {header:'Work Installation Location', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.locationInstallation'}, {header:'Work Performance Location', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.locationPerformance'}, {header:'Work Other Location', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.locationOther'}, {header:'Work Location Notes', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.locationNotes'}, {header:'Work ID', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.refid'}, {header:'Work Rights', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.rights'}, {header:'Work Description', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.description'}, {header:'Work Subject', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.subject'}, {header:'Work Inscription', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.inscription'}, {header:'Work Relation', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.relation'}, {header:'Work Text Reference', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.textref'}, {header:'Work Info Source', customHeader:'',type:'text', namespace:namespace_VRAE, path:'work.source'}, {header:'Work Custom 1 Label', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom1/vrae:_label'}, {header:'Work Custom 1 Data', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom1/vrae:data'}, {header:'Work Custom 2 Label', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom2/vrae:_label'}, {header:'Work Custom 2 Data', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom2/vrae:data'}, {header:'Image View Description', customHeader:'',type:'text', namespace:namespace_VRAE, path:'image.title'}, {header:'Image Original Date', customHeader:'',type:'date', namespace:namespace_PHOTOSHOP, path:'DateCreated'}, {header:'Camera GPS Altitude', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSAltitude'}, {header:'Camera GPS Altitude Ref', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSAltitudeRef'}, {header:'Camera GPS Latitude', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSLatitude'}, {header:'Camera GPS Longitude', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSLongitude'}, {header:'Camera GPS Direction', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSImgDirection'}, {header:'Camera GPS Direction Ref', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSImgDirectionRef'}, {header:'Camera GPS Map Datum', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSMapDatum'}, {header:'Camera GPS Time Stamp', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSTimeStamp'}, {header:'Camera GPS Version ID', customHeader:'',type:'text', namespace:XMPConst.NS_EXIF, path:'GPSVersionID'}, {header:'Image Creator', customHeader:'',type:'seq', namespace:XMPConst.NS_DC, path:'creator'}, {header:'Image Creator job title', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'AuthorsPosition'}, {header:'Image Creator Address', customHeader:'',type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'CreatorContactInfo/Iptc4xmpCore:CiAdrExtadr'}, {header:'Image Creator City', customHeader:'',type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'CreatorContactInfo/Iptc4xmpCore:CiAdrCity'}, {header:'Image Creator Country', customHeader:'',type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'CreatorContactInfo/Iptc4xmpCore:CiAdrCtry'}, {header:'Image Creator Email address(es)', customHeader:'',type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'CreatorContactInfo/Iptc4xmpCore:CiEmailWork'}, {header:'Image Creator Phone number(s)', customHeader:'',type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'CreatorContactInfo/Iptc4xmpCore:CiTelWork'}, {header:'Image Creator Postal Code', customHeader:'',type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'CreatorContactInfo/Iptc4xmpCore:CiAdrPcode'}, {header:'Image Creator State/Province', customHeader:'',type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'CreatorContactInfo/Iptc4xmpCore:CiAdrRegion'}, {header:'Image Creator Web URL(s)', customHeader:'',type:'text', namespace:XMPConst.NS_IPTC_CORE, path:'CreatorContactInfo/Iptc4xmpCore:CiUrlWork'}, {header:'Image VRA Source', customHeader:'',type:'text', namespace:namespace_VRAE, path:'image.source'}, {header:'Image IPTC Source', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'Source'}, {header:'Image Credit Line', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'Credit'}, {header:'Image Copyright Status', customHeader:'',type:'boolean', namespace:XMPConst.NS_XMP_RIGHTS, path:'Marked'}, {header:'Image Creative Commons', customHeader:'',type:'text', namespace:namespace_CC, path:'license'}, {header:'Image Copyright URL', customHeader:'',type:'text', namespace:XMPConst.NS_XMP_RIGHTS, path:'WebStatement'}, {header:'Image Usage Terms', customHeader:'',type:'langAlt', namespace:XMPConst.NS_XMP_RIGHTS, path:'UsageTerms'}, {header:'Image Copyright Notice', customHeader:'',type:'langAlt', namespace:XMPConst.NS_DC, path:'rights'}, {header:'Image Custom 3 Label', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom3/vrae:_label'}, {header:'Image Custom 3 Data', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom3/vrae:data'}, {header:'Image Custom 4 Label', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom4/vrae:_label'}, {header:'Image Custom 4 Data', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom4/vrae:data'}, {header:'Admin Collection', customHeader:'',type:'bag', namespace:XMPConst.NS_DC, path:'publisher'}, {header:'Admin Job Identifier', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'TransmissionReference'}, {header:'Admin Instructions', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'Instructions'}, {header:'Admin Cataloger', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'CaptionWriter'}, {header:'Admin Custom 5 Label', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom5/vrae:_label'}, {header:'Admin Custom 5 Data', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom5/vrae:data'}, {header:'Admin Custom 6 Label', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom6/vrae:_label'}, {header:'Admin Custom 6 Data', customHeader:'',type:'text', namespace:namespace_VRAE, path:'custom6/vrae:data'}, {header:'DC Title', customHeader:'',type:'langAltDcTitle', namespace:XMPConst.NS_DC, path:'title'}, {header:'Summary Description/Caption', customHeader:'',type:'langAltDcDescription', namespace:XMPConst.NS_DC, path:'description'}, {header:'Summary Keywords', customHeader:'',type:'bagDcSubject', namespace:XMPConst.NS_DC, path:'subject'}, {header:'Headline', customHeader:'',type:'text', namespace:namespace_PHOTOSHOP, path:'Headline'}, {header:'Date File Created', customHeader:'',type:'', namespace:'', path:''}, {header:'Date File Modified', customHeader:'',type:'', namespace:'', path:''}, {header:'Format', customHeader:'',type:'file', namespace:'XMPConst.NS_DC', path:'format'}, {header:'File Size', customHeader:'',type:'', namespace:'', path:''}, {header:'Image Width (pixels)', customHeader:'',type:'file', namespace:'XMPConst.NS_EXIF', path:'PixelXDimension'}, {header:'Image Height (pixels)', customHeader:'',type:'file', namespace:'XMPConst.NS_EXIF', path:'PixelYDimension'}, {header:'Bit Depth', customHeader:'',type:'file', namespace:'XMPConst.NS_TIFF', path:'BitsPerSample[1]'}, {header:'Compression', customHeader:'',type:'file', namespace:'XMPConst.NS_TIFF', path:'Compression'}, {header:'Resolution', customHeader:'',type:'', namespace:'', path:''}, {header:'Make', customHeader:'',type:'file', namespace:'XMPConst.NS_TIFF', path:'Make'}, {header:'Model', customHeader:'',type:'file', namespace:'XMPConst.NS_TIFF', path:'Model'}, {header:'Software', customHeader:'',type:'file', namespace:'XMPConst.NS_TIFF', path:'Software'}, {header:'Color Mode', customHeader:'',type:'', namespace:'', path:''}, {header:'Color Profile', customHeader:'',type:'file', namespace:'XMPConst.NS_PHOTOSHOP', path:'ICCProfile'}, {header:'Color Space', customHeader:'',type:'', namespace:'', path:''}];
 
	 // array for custom headers - populated from user prefs or on Headers window "Save"
	var customHeadersArray = [];
	// array for user's imported custom headers
	var mappingListArr = []
     // Default column headers array
    var columnHeaders = ["File Name (required)","File Path (optional)","Work Creator","Work Title","Work Date","Work Style/Period","Work Culture","Work Work Type","Work Materials","Work Techniques","Work Measurements","Work Repository","Work Site","Site Sublocation","Site City","Site Country","Site Country Code","Site Province or State","Site GPS Latitude","Site GPS Longitude","Site GPS Bearing Ref","Site GPS Bearing","Site GPS Distance Ref","Site GPS Distance","Work Creation Location","Work Discovery Location","Work Exhibition Location","Work Installation Location","Work Performance Location","Work Other Location","Work Location Notes","Work ID","Work Rights","Work Description","Work Subject","Work Inscription","Work Relation","Work Text Reference","Work Info Source","Work Custom 1 Label","Work Custom 1 Data","Work Custom 2 Label","Work Custom 2 Data","Image View Description","Image Original Date","Camera GPS Altitude","Camera GPS Altitude Ref","Camera GPS Latitude","Camera GPS Longitude","Camera GPS Direction","Camera GPS Direction Ref","Camera GPS Map Datum","Camera GPS Time Stamp","Camera GPS Version ID","Image Creator","Image Creator job title","Image Creator Address","Image Creator City","Image Creator Country","Image Creator Email address(es)","Image Creator Phone number(s)","Image Creator Postal Code","Image Creator State/Province","Image Creator Web URL(s)","Image VRA Source","Image IPTC Source","Image Credit Line","Image Copyright Status","Image Creative Commons","Image Copyright URL","Image Usage Terms","Image Copyright Notice","Image Custom 3 Label","Image Custom 3 Data","Image Custom 4 Label","Image Custom 4 Data","Admin Collection","Admin Job Identifier","Admin Instructions","Admin Cataloger","Admin Custom 5 Label","Admin Custom 5 Data","Admin Custom 6 Label","Admin Custom 6 Data","DC Title","Summary Description/Caption","Summary Keywords","Headline","Date File Created","Date File Modified","Format","File Size","Image Width (pixels)","Image Height (pixels)","Bit Depth","Compression","Resolution","Make","Model","Software","Color Mode","Color Profile","Color Space"];   
    /////////////////////////////////////////////////
  ////////// MAIN WINDOW//////////
/////////////////////////////////////////////////
		// Create the main dialog box
		var mainWindow = new Window('palette', "VRA Export-Import - "+codeVersion);
		mainWindow.spacing =5
		{ //  main UI window - brace 1 open
		// header
		header =  mainWindow.add( 'group' );
		header.orientation = 'row';
		header.alignment='left';
		title = header.add('statictext', undefined, "Visual Resources Association Metadata Export-Import Tool (compatible with VRA custom info panel version 1.0)");
		title.alignment = 'left';
        title.preferredSize = [720, 20]
	
settingsGroup = mainWindow.add('group', un, un)
	setHeaders = settingsGroup.add('button', undefined, "Using Default Field Names")
	setHeaders.preferredSize = buttonSize9
	setHeaders.onClick = function(){mainWindow.enabled = false; headersOptionsWindow.show(); lastViewedHeadersPanel = "Work"; toggleNavBtns()} //setHeadersFunc
    
		mainWindow.row = mainWindow.add( 'group' );
		mainWindow.row.orientation = 'row';
		mainWindow.row.spacing = 20;
		  
		// Export section
		exportPanel = mainWindow.row.add('panel', undefined, "");
		exportPanel.margins = 3;
        exportPanel.alignment = 'top';
		exportPanel.alignChildren = 'center';

		// Header with title "Export"   
		exportHeader = exportPanel.add('group');
		exportHeader.orientation = 'column';
		exportHeader.spacing = 0;
		exportHeader.preferredSize = [360, undefined]

		exportTitle = exportHeader.add('statictext', undefined, "Export Metadata");
		exportTitle.alignment = 'center';
		exportTitle.justify = 'center';
		exportTitle.preferredSize = [200,20];

		// Export Instructions button
		exportInstButton = exportHeader.add('button', undefined, "?");
		exportInstButton.preferredSize = buttonSize1
		exportInstButton.alignment = 'right';
		exportInstButton.onClick = showExportInst;

		//  Select which files to export 
		var selections = app.document.selections;
		var folder = app.document.visibleThumbnails;

		exportWhich = exportPanel.add('panel', undefined, "Images");
		exportWhich.alignChildren = 'left';
		exportWhich.spacing = 2;
		exportWhich.margins = 5;

		// Spacer
		spacer1 = exportWhich.add( 'group' );
		spacer1.minimumSize = [100, 10]
		  var  exportWhichthumbsRbtext = "Selected thumbnail(s) in Bridge"
          exportWhich.thumbsRb = exportWhich.add('radiobutton', undefined, exportWhichthumbsRbtext);
          exportWhich.thumbsRb.onClick = function(){ 
              exportChoice = "thumbs";
              toggleExportWhich();
              }  
          
		exportWhich.folderRb = exportWhich.add('radiobutton', undefined, "Entire folder");
		exportWhich.folderRb.value = true;
		exportWhich.folderRb.onClick = function(){
			exportChoice = "folder";
			toggleExportWhich();
			} 
        exportWhich.spacer = exportWhich.add('group');
		exportWhich.spacer.preferredSize = [10, 10];
		
        exportWhich.subfoldersGr = exportWhich.add('group');
        exportWhich.subfoldersGr.orientation = 'row';
          exportWhich.subfoldersPath = exportWhich.subfoldersGr.add('statictext', undefined, "folder path:");
           exportWhich.subfoldersPath.preferredSize = [160,20]
		exportWhich.subfoldersCb = exportWhich.subfoldersGr.add('checkbox', undefined, "include subfolders");
		

		exportWhich.folderGr = exportWhich.add('group');
		exportWhich.folderGr.orientation = 'row';
        exportWhich.folderGr.spacing = 2;

		exportWhich.folderEt = exportWhich.folderGr.add('edittext', undefined, "");
		exportWhich.folderEt.preferredSize = [300, 20];
	//	exportWhich.folderEt.helpTip = imageFolderPath;
		exportWhich.folderBrowse = exportWhich.folderGr.add('button', undefined, "Browse");
		exportWhich.folderBrowse.helpTip = imageFolderBrowse
		
		exportWhich.folderEt.Alert = exportWhich.add('statictext', undefined, "? Folder not found.  Keep looking.");
		exportWhich.folderEt.Alert.alignment = 'left';
		exportWhich.folderEt.Alert.indent = 20;
        exportWhich.folderEt.Alert.preferredSize = [200,20]
		exportWhich.folderEt.Alert.visible = false;
          
           // opens file browser to pick the location of the script file before installation can begin
          exportWhich.folderBrowse.onClick =  function(){
         /*   if (!pluginSettingsArray[13]){
                var path = desktopSaveFile;
                }
            else{
                var path = pluginSettingsArray[13].split(" " ).join("%20")
                }
			folder = new Folder(path); */
			var folderPath = Folder.selectDialog("Select a folder of image files for export");
            
            // selected folder path is copied into exportWhich.folderEt.text 
            if (folderPath){
                exportWhich.folderEt.text = folderPath.toString().split ("%20").join (" ");
                testExportImagesFolder();
                exportWhich.folderEt.helpTip = exportWhich.folderEt.text+"\n\n"+imageFolderPath
                }			
			}

		 // Panel for options
         exportOptionsGrp = exportPanel.add('group', un, un);
		
		exportOptions = exportOptionsGrp.add('panel', undefined, 'Options');
		exportOptions.alignChildren = 'left'; 
		exportOptions.spacing = 2;

		exportOptions.dates = exportOptions.add( 'group' );
		exportOptions.dates.orientation = 'row';
		exportOptions.datesCb = exportOptions.dates.add('checkbox', undefined, "prepend Image dates with '_'");
        exportOptions.datesCb.value = true;
		exportOptions.datesCb.minimumSize = [200, undefined];
		exportOptions.datesCb.helpTip = dateWhyTT;

		exportOptionsLf = exportOptions.add( 'group' );
		exportOptionsLf.orientation = 'row';
		exportOptionsLfCb = exportOptionsLf.add('checkbox', undefined, "Remove line breaks");
        exportOptionsLfCb.value = true;
		exportOptionsLfCb.minimumSize = [200, undefined];
		exportOptionsLfCb.helpTip = lineFeedWhyTT;

        // Export Options Instructions button
		exportOptionsButton = exportOptionsGrp.add('button', undefined, "?");
		exportOptionsButton.alignment = 'right';
		exportOptionsButton.preferredSize = buttonSize1
		exportOptionsButton.helpTip = clickInstrucTT;
		exportOptionsButton.onClick = showExportOptInst

		exportBtn = exportPanel.add('button', undefined, "Export");   
		exportBtn.preferredSize = [120, 35];
		exportBtn.enabled = false;
		exportBtn.onClick = exportToFile;

		// check to see if the folder of images specified exists
		function testExportImagesFolder(){
			var selectedFolder = Folder(exportWhich.folderEt.text.split(" ").join("%20"));			
			if (exportWhich.folderEt.text && selectedFolder.exists == false){
				exportImageFolderOK = false;
				exportWhich.folderEt.Alert.visible = true;
				}
			else if (exportWhich.folderEt.text && selectedFolder.exists == true){
				exportImageFolderOK = true;
				exportWhich.folderEt.Alert.visible = false;
				}
			toggleExportBtn();
			}

		function toggleExportBtn(){
			if (exportImageFolderOK == true){
				exportBtn.enabled = true;
				}
			else{
				 exportBtn.enabled = false;
				}
			}
        
		 // test to see if the paths entered by user exist
		exportWhich.folderEt.addEventListener('changing',function(){testExportImagesFolder()});
		
		// If user selects export to "Entire folder", show folder path box, otherwise hide it
		function toggleExportWhich(){
			if (exportChoice == "thumbs"){
				exportWhich.subfoldersGr.visible = false;
				exportWhich.folderGr.visible = false;
                  exportBtn.enabled = true;
				}
			else{
				exportWhich.subfoldersGr.visible = true;
				exportWhich.folderGr.visible = true;
                  toggleExportBtn;
				}
              }
		
		// info windows 
            function showHeaderInst(){
			var headerInst = new Window('palette', "Header Instructions"); 
			headerInst.body = headerInst.add('group');
			headerInst.body.orientation = 'column';
			headerInst.body.spacing = 0;
			   
            var text1 =
            "You have choices.\n\n" +
            "   • 'Default Field Names' will export all of the VRA field names.\n" +
            "         • For import, header names must match the default template.\n" +
            "         • For import, header order does not matter.\n" +
            "         • For import, you do not need to include all columns.\n" +
            "         • Want to see the default template?\n"

            var text2 =			 
            "   • 'Custom Field Names' will export and import using only the field names you choose.\n" +
            "         • You can use selected VRA field names by clicking the '>' button.\n" +
            "         • You can enter your own field names next to the appropriate VRA field names.\n" +
            "              • You are giving a new name to the field names, but the XMP data is still the same.\n" +
            "              • You are mapping the VRA fields to your own fields.\n" +
            "              • Your custom field names will be remembered for next time.\n" +
            "         • For import, only the custom field names in your tab-delimited file will be imported.\n"
          
   
			headerInst.text1 = headerInst.body.add('statictext', undefined, text1, {multiline:true});
			if (Folder.fs == "Windows"){
				headerInst.text1.preferredSize = [540,100];
				}
			else{
				headerInst.text1.preferredSize = [620,130];
				}			
			headerInst.templateBtn = headerInst.body.add ('button', undefined, "Create VRA_import_default template.txt");
			headerInst.templateBtn.helpTip = createTemplateTT;
			headerInst.templateBtn.alignment = 'left';
			headerInst.templateBtn.indent = 50;
            headerInst.templateBtn.preferredSize = [300,25]
			headerInst.templateBtn.onClick  = createTemplate; 
            headerInst.spacer = headerInst.body.add('statictext', undefined, "");
            headerInst.spacer.preferredSize = [1,40]
			headerInst.text2 = headerInst.body.add('statictext', undefined, text2, {multiline:true});
			if (Folder.fs == "Windows"){
				headerInst.text2.preferredSize = [540,120];
				}
			else{
				headerInst.text2.preferredSize = [620,150];
				}
			headerInst.cancelBtn = headerInst.add('button', undefined, 'Close');
			headerInst.cancelBtn.onClick =  function(){ 
				headerInst.hide();
				}  
			
			headerInst.show();
		}
        
          function showExportInst(){
               var ExportInst = new Window('palette', "Export Instructions");
               var body =
               "This script creates a tab delimited text file containing all of the metadata fields used in the VRA custom XMP panels.\n\n" +
               "   • Choose which files to export.\n\n" +
               "         • To extract specific file(s) \n" +
               "              • select the file(s) in Adobe Bridge,\n" +
               "              • choose 'Selected files'\n" +
               "              • click 'Export'\n\n" +
               "         • To extract all image files in a folder\n" +
               "              • select 'Entire folder'\n" +
			 "              • If you want to export images in all subfolders\n" +
			 "                   • check the box 'include subfolders'\n\n" +
               "    • Choose a location and name for your export file (.txt format)\n\n" +
			 "    • Click 'Export'\n\n" +
               "    • After export is complete\n" +
			 "        Open your .txt file in a spreadsheet using tab delimiters.\n" +
			 "              • To assure diacritics are properly displayed, choose\n"+
             "                  Unicode (UTF-8)\n" +
			 "                 when opening the text file in your spreadsheet.\n" +
               "              • The first row will contain the field names.";
               ExportInstText = ExportInst.add('statictext', undefined, body, {multiline:true});
			   if (Folder.fs == "Windows"){
				ExportInstText.preferredSize = [380,370];
				}
			else{
				ExportInstText.preferredSize = [450, 450];
				}
               ExportInst.cancelBtn = ExportInst.add('button', undefined, 'Close');
			ExportInst.cancelBtn.onClick =  function(){ 
				ExportInst.hide();
				}
               ExportInst.show();
			}
			function showExportOptInst(){
			var exportOptInst = new Window('palette', "Export Options");
               var body =
					"Option 1:  prepend Image dates with '_'\n"+
					"     This is useful if you will be importing the metadata to Excel.\n" +
					"     XMP Date values must use the YYYY/MM/DD format.  Adding a '_' character at the beginning\n"+
					"     of the Date will prevent Excel from automatically changing it to a format XMP cannot understand.\n" +
					"     The '_' character will be removed when you import the data back into the image file(s).\n\n"+
					"Option 2:  Remove line breaks\n"+		   
					"     This is useful if you will be importing the metadata to Excel.\n" +
					"     When selected, line breaks (line feed and carriage return) will be replaced by\n"+
					"     a semi-colon and a space ('; ').\n"+
					"     When not selected, line breaks will be retained but converted to plain text place holders\n"+
					"     ('LF'), ('CR') so that they are not changed by Excel.  When the data is imported back to an image,\n"+
					"     the codes will be changed to the proper XMP encoding."
               exportOptInstText = exportOptInst.add('statictext', undefined, body, {multiline:true});
			   if (Folder.fs == "Windows"){
				exportOptInstText.preferredSize = [600,200];
				}
			else{
				exportOptInstText.preferredSize = [650, 250];
				}
               exportOptInst.cancelBtn = exportOptInst.add('button', undefined, 'Close');
			exportOptInst.cancelBtn.onClick =  function(){ 
				exportOptInst.hide();
				}
               exportOptInst.show();
			   }
		
		function showimportOptInst(){
               var importOptInst = new Window('palette', "Import Options");
               var body =
			   "Option 1: Ignore file extensions\n"+
				"     When selected, metadata will be imported to all matching media with matching file names\n"+
				"     regardless of the file extension.\n"+
				"     This allows you to import matching metadata to all versions of the same media file,\n"+
				"     e.g., .tif, .jpg. .png.\n\n"+
				"Option 2: Create Title (IPTC)\n"+
				"     When selected, the Title (dc:title) will be filled with the data values from VRA  fields:\n"+
				"     Work Title; Image view\n\n"+
				"Option 3: Create Description/Caption (IPTC)\n"+
				"     When selected, the Description/Caption (dc:description) will be filled with the data values\n"+
				"     from VRA Work fields:\n"+
				"     Creator; Title, View; Date; Work Type; Materials; Measurements; Repository; Location; Rights\n\n"+
				"Option 4: Create Keywords (IPTC)\n"+
				"     When selected, Keywords (dc:subject) will be filled with the data values from VRA Work fields:\n"+
				"     Subject; Style/Period; Culture; Work Type; Technique; Site\n\n"+
				"Option 5: Set Thumbnail Label\n"+	
				"     When selected, each image that has metadata successfully imported will have its label set to:\n"+
				"     'VRA metadata imported' and the label color will be changed to white.\n"+
				"     Warning: Existing labels will be lost.";
               importOptInstText = importOptInst.add('statictext', undefined, body, {multiline:true});
			   if (Folder.fs == "Windows"){
				importOptInstText.preferredSize = [550,340];
				}
			else{
				importOptInstText.preferredSize = [650, 400];
				}
               importOptInst.cancelBtn = importOptInst.add('button', undefined, 'Close');
			importOptInst.cancelBtn.onClick =  function(){ 
				importOptInst.hide();
				}
               importOptInst.show();
			}
		// Panel for Import section
		importPanel = mainWindow.row.add('panel', undefined, "");
		importPanel.margins = 3;
		importPanel.alignChildren = 'center';
        
		header = importPanel.add( 'group' ); 
		header.orientation = 'column';
		header.spacing = 0;
		header.preferredSize = [360, undefined]

		importTitle = header.add('statictext', undefined, 'Import Metadata');
		importTitle.alignment = 'center';
		importTitle.justify = 'center';
        importTitle.preferredSize = [200,20];
 
		// Info button
		importInstButton = header.add('button', undefined, "?");
		importInstButton.preferredSize = buttonSize1
        importInstButton.alignment = 'right';
		importInstButton.helpTip = clickInstrucTT;
		importInstButton.onClick = function showImportInst(){
			var ImportInst = new Window('palette', "Import Instructions"); 
			ImportInst.body = ImportInst.add('group');
			ImportInst.body.orientation = 'column';
			ImportInst.body.spacing = 3;		   
            var text1 =
            "This script imports data from a tab delimited text file into image files with matching filenames.\n\n" +
            "     If you select 'Use Deault Field Names':\n" +
            "         • For import, header names must match the default template.\n" +
            "         • For import, header order does not matter.\n" +
            "         • For import, you do not need to include all columns.\n\n" +
            "     If you select 'Use Custom Field Names':\n" +
            "         • The tab delimited text file must have your custom field names.\n" +
            "         • Column order does not matter.\n\n" +
            "      If you have already exported metadata and edited it in Excel and want to import it back in:\n" +
			"         • select the folder containing the target images\n" +
			"              • if you have nested folders, check 'include subfolders'\n" +
			"         • select the text file to be imported\n" +
			"              • click 'Import' and cross your fingers\n\n" +
			"     If you are starting with external metadata (from a database, etc.)\n" +
			"         • First, you need a properly formatted template:"

			var text2 =			 
			"         • Look for this new file on your desktop\n" +
			"         • Open the template in Excel:\n" +
			"              • open the text file in Excel\n" +
			"              • add data to the appropriate columns\n" +
			"              • save as a tab-delimited text file\n\n" +
			"         • To import data into image files:\n" +
			"              • select the folder containing the target images\n" +
			"              • if you have nested folders, check 'include subfolders'\n" +
			"              • select the text file to be imported\n" +
			"              • click 'Import' and cross your fingers";
   
			ImportInst.text1 = ImportInst.body.add('statictext', undefined, text1, {multiline:true});
			if (Folder.fs == "Windows"){
				ImportInst.text1.preferredSize = [540,270];
				}
			else{
				ImportInst.text1.preferredSize = [620,320];
				}			
			ImportInst.templateBtn = ImportInst.body.add ('button', undefined, "Create VRA_import_default template.txt");
			ImportInst.templateBtn.helpTip = createTemplateTT;
			ImportInst.templateBtn.alignment = 'left';
			ImportInst.templateBtn.indent = 50;
			ImportInst.templateBtn.onClick  = createTemplate; 
			ImportInst.text2 = ImportInst.body.add('statictext', undefined, text2, {multiline:true});
			if (Folder.fs == "Windows"){
				ImportInst.text2.preferredSize = [540,180];
				}
			else{
				ImportInst.text2.preferredSize = [620,220];
				}
			ImportInst.cancelBtn = ImportInst.add('button', undefined, 'Close');
			ImportInst.cancelBtn.onClick =  function(){ 
				ImportInst.hide();
				}  
			
			ImportInst.show();
		}
    
		// Select image files location
		imageLocBox = importPanel.add('panel', undefined, "Images in a folder");
		imageLocBox.spacing = 2;
        imageLocBox.margins = 5;      
         // Spacer
		spacer3 = imageLocBox.add( 'group' );
		spacer3.minimumSize = [100, 10]
		imageLocLblGrp = imageLocBox.add('group');
		imageLocLblGrp.orientation = 'row';
		imageLocLblGrp.alignment = 'left';
	//	imageLocLblGrp.spacing = 100
		imageLocLblGrp.indent = 3//55;
        imageLocSubfoldersLbl = imageLocLblGrp.add('statictext', undefined, "folder path:");
        imageLocSubfoldersLbl.preferredSize = [160,20]
		imageLocSubfoldersCb = imageLocLblGrp.add('checkbox', undefined, "include subfolders");		
		imageLocSubfoldersCb.alignment = 'left';
	//	imageLocSubfoldersCb.indent = 60;
		imageLocSubfoldersCb.onClick = function toggleImportSub(){
			if (imageLocSubfoldersCb.value == true){
				dataSourceOptions.enabled = true
				IgnoreExtCb.value = false;
				IgnoreExtCb.enabled = false;
				}
			if (imageLocSubfoldersCb.value == false){
				dataSourceOptions.enabled = false;
				dataSourceOptions.Name.value = true;
				dataSourceOptions.Path.value = false;
				IgnoreExtCb.value = true;
				IgnoreExtCb.enabled = true;
				}
			}

		imageLocGroup = imageLocBox.add('group');
		imageLocGroup.orientation = 'row';
        imageLocGroup.spacing = 2;
		imageLoc = imageLocGroup.add('edittext', undefined, "");
		imageLoc.preferredSize = [300, 20];
	//	imageLoc.helpTip = imageFolderPath;
		imageLocBrowse = imageLocGroup.add('button', undefined, "Browse");
		imageLocBrowse.helpTip = imageFolderBrowse;
		imageLocAlert = imageLocBox.add('statictext', undefined, "? Folder not found.  Keep looking.");
		imageLocAlert.alignment = 'left';
		imageLocAlert.justify = 'left';
		imageLocAlert.indent = 20;
        imageLocAlert.preferredSize = [200,20]
	imageLocAlert.visible = false
	  
		// opens file browser to pick the location of the image files 
		imageLocBrowse.onClick =  function(){
		var folderPath = Folder.selectDialog("Select a folder of image files to import metadata");
            if (folderPath){
                imageLoc.text = folderPath.toString().split ("%20").join (" ");
                testImportImagesFolder();
                imageLoc.helpTip = imageLoc.text+"\n\n"+imageFolderPath
                }
			}
		 
		// Select the .txt  file to be imported
		dataSourceBox = importPanel.add('panel', undefined, "Metadata text file");
		dataSourceBox.spacing = 3;
		dataSourceBox.margins = 5;
		// Spacer
		spacer4 = dataSourceBox.add( 'group' );
		spacer4.minimumSize = [100, 10];
		dataSourceGrp = dataSourceBox.add('statictext', undefined, "file path:");
		dataSourceGrp.alignment = 'left';
		dataSourceGrp.indent = 3//68;
        dataSourceGrp.preferredSize = [160,20]
		dataSourceGroup = dataSourceBox.add('group');
		dataSourceGroup.orientation = 'row';      
		dataSourceGroup.spacing = 2;
		dataSource = dataSourceGroup.add('edittext', undefined, "");
		dataSource.preferredSize = [300, 20];
	//	dataSource.helpTip = textFilePath+dataSource.text;
		dataSourceBrowse = dataSourceGroup.add('button', undefined, "Browse");
		dataSourceBrowse.helpTip = textFileBrowse;
		dataSourceFileAlert = dataSourceBox.add('statictext', undefined, "? File not found.  Keep looking.");
		dataSourceFileAlert.alignment = 'left';
		dataSourceFileAlert.justify = 'left';
        dataSourceFileAlert.preferredSize = [200,20]
		dataSourceFileAlert.indent = 20;
		dataSourceFileAlert.visible = false;
        
          // opens file browser to pick the location of the metadata text file to be imported to images
          dataSourceBrowse.onClick =  function(){
            var filePath = File.openDialog( 'Select the text file (.txt)',  "TXT  Files:*.txt" );
                if(filePath){
                dataSource.text = filePath.toString().split ("%20").join (" ");
                testTextFileExists();
                dataSource.helpTip = dataSource.text+"\n\n"+textFilePath
                }
		}
		  
		dataSourceOptions = importPanel.add('panel', undefined, "Match on");
		dataSourceOptions.Name = dataSourceOptions.add('radiobutton', undefined, "Filename");
        dataSourceOptions.Name.value = true;
		dataSourceOptions.Name.helpTip = "Example:\n 00252901.tif";
		dataSourceOptions.Path = dataSourceOptions.add('radiobutton', undefined, "Path and filename");
		dataSourceOptions.alignChildren = 'left';
		dataSourceOptions.Path.helpTip = "Example:\n C:/Architecture/Trajans_Column/Large/00252901.tif";
	     dataSourceOptions.minimumSize = [275, undefined]
		dataSourceOptions.spacing = 2;		

		writeOptions = importPanel.add('panel', undefined, "Existing Data");
		writeOptions.minimumSize = [275, undefined]
		writeOptions.spacing = 2;
		writeOptions.overwriteRb = writeOptions.add('radiobutton', undefined, "Overwrite all fields");   
		writeOptions.overwriteRb.value = true
		writeOptions.overwriteRb.helpTip = replaceDataTT;
		writeOptions.appendRb = writeOptions.add('radiobutton', undefined, "Write only to empty fields");
        writeOptions.appendRb.value = true;
		writeOptions.appendRb.helpTip = appendDataTT;
		writeOptions.alignChildren = 'left';
		writeOptions.minimumSize = [275, undefined]	
		// Panel for options
         importOptionsGrp = importPanel.add('group', un, un);
		 
		importOptions = importOptionsGrp.add('panel', undefined, "Options");	 
		importOptions.alignChildren = 'left';
		importOptions.minimumSize = [275, undefined]
		importOptions.spacing = 2;

		ignoreExt = importOptions.add('group', undefined, "");
		IgnoreExtCb = ignoreExt.add('checkbox', undefined, "Ignore file extensions");
		IgnoreExtCb.minimumSize = [200, undefined];	
		IgnoreExtCb.helpTip = IgnoreExtCbTT;

         fillTitle = importOptions.add('group', undefined, "");
		fillTitleCb = fillTitle.add('checkbox', undefined, "Create Title (IPTC)");
		fillTitleCb.minimumSize = [200, undefined];	
		fillTitleCb.helpTip = createTitleTT;
        
		fillCpt = importOptions.add('group', undefined, "");
		fillCptCb = fillCpt.add('checkbox', undefined, "Create Description/Caption (IPTC)");
		fillCptCb.minimumSize = [200, undefined];	
		fillCptCb.helpTip = createDescriptionTT;

		fillSubj = importOptions.add('group', undefined, "");
		fillSubjCb = fillSubj.add('checkbox', undefined, "Create Keywords (IPTC)");
		fillSubjCb.minimumSize = [200, undefined];	
		fillSubjCb.helpTip = createKeywordsTT;

		addLabel = importOptions.add('group', undefined, "");
		addLabelCb = addLabel.add('checkbox', undefined, "Set Thumbnail Label");
		addLabelCb.minimumSize = [200, undefined];	
		addLabelCb.helpTip = addLabelTT; 
	  
	  // import Options Instructions button
		importOptionsButton = importOptionsGrp.add('button', undefined, "?");
		importOptionsButton.alignment = 'right';
		importOptionsButton.preferredSize = buttonSize1
		importOptionsButton.helpTip = clickInstrucTT;
		importOptionsButton.onClick = showimportOptInst	
// here! dead on re-open on Mac		
////////////////////////// SET HEADERS OPTIONS WINDOW ////////////////////////////////
var headersOptionsWindow = new Window("palette", "Select Fields", un, );
headersOptionsWindow.margins = [10,10,10,30]
headersOptionsWindow.spacing = 5;
headersOptionsWindow.orientation = 'column';
headersOptionsWindow.onClose = function(){mainWindow.enabled = true;}
//headersOptionsWindow.preferredSize = [400,300]
	setHeadersInstButton = headersOptionsWindow.add('button', undefined, "?");
	setHeadersInstButton.alignment = 'center'
    setHeadersInstButton.preferredSize = buttonSize1
    setHeadersInstButton.onClick = showHeaderInst;

opt = headersOptionsWindow.add ('panel',un)
    opt.spacing = 3
    opta = opt.add('statictext',un,"Use default headers")
    opta.preferredSize = [350,20]
    useDefault = opt.add('button',un,"OK")
    useDefault.alignment = 'center'
	useDefault.onClick = function(){customheadersOptChoice = "manuallyChoose"; buttonsChoice.defaultHeadersRb.value = true; toggleCustomHeaders(); headersOptionsWindow.hide(); mainWindow.enabled = true}//setHeadersFunc()

optSapcer1 =  headersOptionsWindow.add('statictext',un,"")
optSapcer1.preferredSize = [0,20]
opts = headersOptionsWindow.add('statictext',un,"There are three ways to set Custom Fields:")
opts.preferredSize = [350,20]	

opt1 = headersOptionsWindow.add ('panel',un)
    opt1.spacing = 3
    opt1a = opt1.add('statictext',un,"1. Choose from the default fields list")
    opt1a.preferredSize = [330,20]
    opt1b = opt1.add('statictext',un,"2. Manually enter your own fields")
    opt1b.preferredSize = [330,20]
    manuallyChoose = opt1.add('button',un,"OK")
    manuallyChoose.alignment = 'center'
	manuallyChoose.onClick = function(){customheadersOptChoice = "manuallyChoose"; buttonsChoice.customHeadersRb.value = true; setHeadersFunc()}

opt2 = headersOptionsWindow.add ('panel',un)
    opt2.spacing = 3
    opt2a = opt2.add('statictext',un,"3. Import a list of your fields and select from them")
    opt2a.preferredSize = [330,20]
    importList = opt2.add('button',un,"OK")
    importList.alignment = 'center'
	importList.onClick = function(){customheadersOptChoice = "importList"; showGetMyFields()}
//	
getMyFields = new Window ('palette', "")
pasteHeaders = getMyFields.add('group')
    pasteHeaders.orientation = 'column'
    pasteHeaders.alignment='right'
    pasteHeaders.spacing = 3
    
    instText = 
    "Paste your Excel header row (row 1) below\n"+
	"or\n"+
    "Paste a vertical list of fields below"
    inst = pasteHeaders.add('statictext', un, instText, {multiline: true})
    inst.preferredSize = [300,60]

    input = pasteHeaders.add('edittext', un, "", {multiline: true})
    input.preferredSize = [300,500]	
	input.addEventListener ('changing', function(){toggleOkBtn(); cleanTabbedInput()})	
 // todo: pressing Enter adds carriage return  - caret moves to beginning. can't set it to newline
 /*
input.addEventListener ("keydown", function (kd) {pressed (kd)});
function pressed (k){
	if(k.keyName == "Enter"){
		input.text = "\n"+input.text
		}
	}
*/	
buttons = getMyFields.add('group')
    okBtn = buttons.add('button', un, "OK, now map these fields")
	okBtn.preferredSize = buttonSize8
	okBtn.enabled = false
    okBtn.onClick = function(){openImportList()}
    cancelBtn = buttons.add('button', un, "Cancel")
	cancelBtn.preferredSize = buttonSize3
    cancelBtn.onClick = function(){getMyFields.close(); mainWindow.enabled = true}

var importingPlt = new Window ('palette', "")
importingPlt.preferredSize = [200,100]
importingPlt.alignChildren = ['center','center']
importingPltText = importingPlt.add('statictext', un, "Importing field list...")
importingPltText.preferredSize = [200,20]
importingPltText.justify = 'center'

function showGetMyFields(){
	headersOptionsWindow.hide()
	 getMyFields.center(); getMyFields.show();
	}
function toggleOkBtn(){
	if(input.text){
		okBtn.enabled = true
		}
	else{
		okBtn.enabled = false
		}
	}
function cleanTabbedInput(){
    // /^[A-Za-z] /matches the first character and says that it must be a letter of some sort.
    // input.text.charAt(0)
    // input.text.substr(1);
    // here! what if there are no tabs, just newlines?
    // here!  add blank at beginning of array so user can empty a field. then, add logic to handle blank in custom list
    input.text = input.text.split("\r\n").join("\n").split("\t").join("\n")
	mappingListArr = input.text.split("\n")
    mappingListArr.unshift("")
   		/* not needed if(mappingListArr.length > 1 && !mappingListArr[mappingListArr.length]){
			mappingListArr = mappingListArr.slice(0, -1)   //todo: fix
			}*/
 //  input.text = mappingListArr.join("\n") // here! need \r for older Macs?
	}

function openImportList(){
	getMyFields.hide()
	importingPlt.show()
     customheadersOptChoice = "importList"
 //    alert("Importing your fields...")  //todo: close when finished.  use a progress bar?
	setHeadersFunc()
    }

////////////////////////// SET HEADERS WINDOW ////////////////////////////////
var headersWindow = new Window("palette", "Set Field Names", un, );
headersWindow.margins = 20;
headersWindow.spacing = 3;
headersWindow.orientation = 'column';

// Buttons
buttons = headersWindow.add('group',un, [un,un,un,un]);
buttons.alignChildren = ['top', 'center']
buttons.orientation = 'row';
buttons.preferredSize = [900,20]

headersWindowHelpBtn = buttons.add('button', un, "?")
headersWindowHelpBtn.preferredSize = buttonSize1
headersWindowHelpBtn.alignment = 'right'
headersWindowHelpBtn.onClick = showheadersWindowHelp
function showheadersWindowHelp(){
               var ExportInst = new Window('palette', "Set Field Names Instructions");
               var body =
				"If you want to export or import all of the default fields:\n\n" +
				"   • Click 'Use Default Field Names'.\n\n" +
				"         • You will get all of the fields you see listed.\n\n" +
				"         • If you have already entered custon fields\n" +
				"              • these will be retained in case you want to use them later.\n\n" +
				"    • Click Custom 'Field Names'\n\n" +
				"         • To use ony a few Default fields:\n"+
				"             • Click the '>' button to move them over to your 'Custom fields' list\n"+
				"         • To use your own Custom field names\n"+
				"              • Enter your Custom field name beside the corresponding Default field name\n"+
				"              • You are mapping your field to the Default field with the same meaning"
               ExportInstText = ExportInst.add('statictext', undefined, body, {multiline:true});
			   if (Folder.fs == "Windows"){
				ExportInstText.preferredSize = [480,250];
				}
			else{
				ExportInstText.preferredSize = [550, 300];
				}
               ExportInst.cancelBtn = ExportInst.add('button', undefined, 'Close');
			ExportInst.cancelBtn.onClick =  function(){ 
				ExportInst.hide();
				}
               ExportInst.show();
			}

buttonsSpacer1 = buttons.add('statictext', un, "")
buttonsSpacer1.preferredSize = [40,20]

buttonsChoice = buttons.add('group',un, un);
buttonsChoice.defaultHeadersRb = buttons.add('radiobutton', un, "Use Default Field Names");
buttonsChoice.defaultHeadersRb.value = true;
buttonsChoice.defaultHeadersRb.preferredSize = [200,20]
buttonsChoice.customHeadersRb = buttons.add('radiobutton', un, "Use Custom Field Names");
buttonsChoice.customHeadersRb.preferredSize = [200,20]
buttonsChoice.customHeadersRb.value = false

customOptions = buttons.add('button', un, "Custom Options")
customOptions.onClick = function(){mainWindow.enabled = false; headersOptionsWindow.show(); saveCustomHeaders()}

buttonsSpacer2 = buttons.add('statictext', un, "")
buttonsSpacer2.preferredSize = [40,20]

clearCustom = buttons.add('button', un, "Clear Custom");// save custom to custom array, close window
    clearCustom.preferredSize = buttonSize5
    clearCustom.alignment = 'right'
    clearCustom.onClick = clearCustomHeaders;
    
buttonsChoice.defaultHeadersRb.onClick = function(){
	toggleCustomHeaders()
//	setHeaders.text = "Using Default Field Names"
    };
buttonsChoice.customHeadersRb.onClick = function(){
	toggleCustomHeaders()
//	setHeaders.text = "Using Custom Field Names"
    };

// Headers
cols = headersWindow.add('group',un, un);
cols.orientation = 'row';
cols.margins = [0,10,20,10]
cols.spacing = 0
cols.alignChildren = ['left', 'top']
    /////////////////////////////////////////////////////////
  //////////////// NAVIGATION ////////////////
/////////////////////////////////////////////////////////
navCol = cols.add('group',un,un)
	navCol.orientation = 'column'
	navCol.alignChildren = ['left', 'top']
	navCol.margins = [0,10,0,0]
	navCol.spacing = 5
	navCol.minimumSize = colSize1
	navCol.maximumSize = colSize1
wrkBtn = navCol.add('button', undefined, "Work")
	wrkBtn.preferredSize = buttonSize7a
	wrkBtn.alignment = 'left'
imgBtn = navCol.add('button', undefined, "Image")
	imgBtn.preferredSize = buttonSize7a
	imgBtn.alignment = 'left'
admSumBtn = navCol.add('button', undefined, "Admin/Summary")
	admSumBtn.preferredSize = buttonSize7a
	admSumBtn.alignment = 'left'
// navigation button clicks
wrkBtn.onClick = toggleNavBtns
imgBtn.onClick = toggleNavBtns
admSumBtn.onClick = toggleNavBtns
   /////////////////////////////////////////////////
  //////////////// FIELDS ////////////////
/////////////////////////////////////////////////
/// fields column
fieldsCol1 = cols.add('group',un,un)
fieldsCol1.orientation = 'stack'
fieldsCol1.alignChildren = ['left', 'top']// [horizontal, vertical]
fieldsCol1.alignment = 'top'
fieldsCol1.margins = [0,0,0,0]
// Work headers
workHeaderGrp =  fieldsCol1.add('group',un, un);
	workHeaderGrp.orientation = 'row';
	workHeaderGrp.alignment = 'top';
	workHeaderGrp.spacing = 20;
	workHeaderGrp.visible = false
// column 1	
workHeaderLists1 = workHeaderGrp.add('group',un, un);
	workHeaderLists1.orientation = 'row';
	workHeaderLists1.alignment = 'top';
	workHeaderLists1.spacing = 0;
workDefaultHeaders1 = workHeaderLists1.add('panel',un, un);
	workDefaultHeaders1.alignChildren = ['right', 'top'];
	workDefaultHeaders1.orientation = 'column';
	workDefaultHeaders1.spacing = headerListSpacing;
	workDefaultHeaders1.margins = 0
workCopyDefault1 = workHeaderLists1.add('group',un, un);
	workCopyDefault1.alignChildren = ['right', 'top'];
	workCopyDefault1.orientation = 'column';
	workCopyDefault1.spacing =  headerUseBtnSpacing;
	workCopyDefault1.margins = 0
workCustomHeaders1 = workHeaderLists1.add('panel',un, un);
	workCustomHeaders1.alignChildren = ['right', 'top'];
	workCustomHeaders1.orientation = 'column';
	workCustomHeaders1.spacing = headerListSpacing;
	workCustomHeaders1.margins = 0
//column 2
workHeaderLists2 = workHeaderGrp.add('group',un, un);
	workHeaderLists2.orientation = 'row';
	workHeaderLists2.alignment = 'top';
	workHeaderLists2.spacing = 0;
workDefaultHeaders2 = workHeaderLists2.add('panel',un, un);
	workDefaultHeaders2.alignChildren = ['right', 'top'];
	workDefaultHeaders2.orientation = 'column';
	workDefaultHeaders2.spacing = headerListSpacing;
	workDefaultHeaders2.margins = 0
workCopyDefault2 = workHeaderLists2.add('group',un, un);
	workCopyDefault2.alignChildren = ['right', 'top'];
	workCopyDefault2.orientation = 'column';
	workCopyDefault2.spacing =  headerUseBtnSpacing;
	workCopyDefault2.margins = 0
workCustomHeaders2 = workHeaderLists2.add('panel',un, un);
	workCustomHeaders2.alignChildren = ['right', 'top'];
	workCustomHeaders2.orientation = 'column';
	workCustomHeaders2.spacing = headerListSpacing;
	workCustomHeaders2.margins = 0

// Image headers
imageHeaderGrp =  fieldsCol1.add('group',un, un);
	imageHeaderGrp.orientation = 'row';
	imageHeaderGrp.alignment = 'top';
	imageHeaderGrp.spacing = 20;
	imageHeaderGrp.visible = false
// column 1
imageHeaderLists1 = imageHeaderGrp.add('group',un, un);
	imageHeaderLists1.orientation = 'row';
	imageHeaderLists1.alignment = 'top';
	imageHeaderLists1.spacing = 0;
imageDefaultHeaders1 = imageHeaderLists1.add('panel',un, un);
	imageDefaultHeaders1.alignChildren = ['right', 'top'];
	imageDefaultHeaders1.orientation = 'column';
	imageDefaultHeaders1.spacing = headerListSpacing;
	imageDefaultHeaders1.margins = 0
imageCopyDefault1 = imageHeaderLists1.add('group',un, un);
	imageCopyDefault1.alignChildren = ['right', 'top'];
	imageCopyDefault1.orientation = 'column';
	imageCopyDefault1.spacing = headerUseBtnSpacing;
	imageCopyDefault1.margins = 0
imageCustomHeaders1 = imageHeaderLists1.add('panel',un, un);
	imageCustomHeaders1.alignChildren = ['right', 'top'];
	imageCustomHeaders1.orientation = 'column';
	imageCustomHeaders1.spacing = headerListSpacing;
	imageCustomHeaders1.margins = 0
// column 2
imageHeaderLists2 = imageHeaderGrp.add('group',un, un);
	imageHeaderLists2.orientation = 'row';
	imageHeaderLists2.alignment = 'top';
	imageHeaderLists2.spacing = 0;
imageDefaultHeaders2 = imageHeaderLists2.add('panel',un, un);
	imageDefaultHeaders2.alignChildren = ['right', 'top'];
	imageDefaultHeaders2.orientation = 'column';
	imageDefaultHeaders2.spacing = headerListSpacing;
	imageDefaultHeaders2.margins = 0
imageCopyDefault2 = imageHeaderLists2.add('group',un, un);
	imageCopyDefault2.alignChildren = ['right', 'top'];
	imageCopyDefault2.orientation = 'column';
	imageCopyDefault2.spacing = headerUseBtnSpacing;
	imageCopyDefault2.margins = 0
imageCustomHeaders2 = imageHeaderLists2.add('panel',un, un);
	imageCustomHeaders2.alignChildren = ['right', 'top'];
	imageCustomHeaders2.orientation = 'column';
	imageCustomHeaders2.spacing = headerListSpacing;
	imageCustomHeaders2.margins = 0
	
// Image headers
adminSumHeaderGrp =  fieldsCol1.add('group',un, un);
	adminSumHeaderGrp.orientation = 'row';
	adminSumHeaderGrp.alignment = ['left', 'top']
	adminSumHeaderGrp.spacing = 20;
	adminSumHeaderGrp.visible = false
// column 1
adminSumHeaderLists = adminSumHeaderGrp.add('group',un, un);
adminSumHeaderLists.orientation = 'row';
adminSumHeaderLists.alignment = 'top';
adminSumHeaderLists.spacing = 0;
adminSumDefaultHeaders = adminSumHeaderLists.add('panel',un, un);
adminSumDefaultHeaders.alignChildren = ['right', 'top'];
adminSumDefaultHeaders.orientation = 'column';
adminSumDefaultHeaders.spacing = headerListSpacing;
adminSumDefaultHeaders.margins = 0

adminSumCopyDefault = adminSumHeaderLists.add('group',un, un);
adminSumCopyDefault.alignChildren = ['right', 'top'];
adminSumCopyDefault.orientation = 'column';
adminSumCopyDefault.spacing = headerUseBtnSpacing;
adminSumCopyDefault.margins = 0

adminSumCustomHeaders = adminSumHeaderLists.add('panel',un, un);
adminSumCustomHeaders.alignChildren = ['right', 'top'];
adminSumCustomHeaders.orientation = 'column';
adminSumCustomHeaders.spacing = headerListSpacing;
adminSumCustomHeaders.margins = 0

//Technical headers
techHeaderLists = fieldsCol1.add('group',un, un);
techHeaderLists.orientation = 'column';
techHeaderLists.spacing = 0;
techHeaderLists.margins = [0,0,0,0];
techHeaderLists.visible = false

footer = headersWindow.add('group')

buttonsSave = footer.add('button', un, "Save and Close");// save custom to custom array, close window
    buttonsSave.preferredSize = buttonSize8
    buttonsSave.alignment = 'right'
    buttonsSave.onClick = saveCustomHeaders;
footerSpacer1 = footer.add('statictext', un, "")
footerSpacer1.preferredSize = [50,0]
/*
// Cancel button
headersWindowClose = footer.add('button', un, "Cancel");
headersWindowClose.preferredSize = buttonSize5
    headersWindowClose.onClick =  function(){ 
        $.writeln(setHeaders.text)
        headersWindow.hide();
        mainWindow.enabled = true
        } 
*/
// Functions
headersWindow.onClose = function(){mainWindow.enabled = true;}

function addWorkHeader(){
	//column 1
	while(workDefaultHeaders1.children.length > 0){
		workDefaultHeaders1.remove(0)
		}
	while(workCopyDefault1.children.length > 0){
		workCopyDefault1.remove(0)
		}
	while(workCustomHeaders1.children.length > 0){
		workCustomHeaders1.remove(0)
		}
    for(var L1 = 0; L1 < 24; L1++){    
        newLabel = workDefaultHeaders1.add('statictext', un, columnHeaders[L1]);
        newLabel.preferredSize = editMSml;
        newLabel.id = "defaultHeader"+[L1];   	
       
		// if manually choose, use edtitext boxes
		if(customheadersOptChoice == "manuallyChoose"){
			newEditText = workCustomHeaders1.add('edittext', un, un);	
			newEditText.preferredSize = editMSml;
			newEditText.text = headerObject[L1].customHeader
			}
		if(customheadersOptChoice == "importList"){
			newEditText = workCustomHeaders1.add('dropdownlist', un, un, {items: mappingListArr});
			newEditText.preferredSize = editMSml
			}
		newEditText.enabled = false    
		newEditText.id = "customHeader"+[L1];		
		newCopyBtn = workCopyDefault1.add( 'button', un, ">");
		newCopyBtn.preferredSize = buttonSize1a
		newCopyBtn.enabled = false
		newCopyBtn.helpTip = useDefaultBtnTT
		newCopyBtn.id = "copyButton"+[L1]
	 	newCopyBtn.onClick = function(){
			var index = this.id.split("copyButton").join("")           
			workCustomHeaders1.children[index].text = workDefaultHeaders1.children[index].text 
			}
       
		}
	//column 2			
	while(workDefaultHeaders2.children.length > 0){
		workDefaultHeaders2.remove(0)
		}
	while(workCopyDefault2.children.length > 0){
		workCopyDefault2.remove(0)
		}
	while(workCustomHeaders2.children.length > 0){
		workCustomHeaders2.remove(0)
		}
    for(var L2 = 24; L2 < 43; L2++){    
        newLabel = workDefaultHeaders2.add('statictext', un, columnHeaders[L2]);
        newLabel.preferredSize = editMSml;
        newLabel.id = "defaultHeader"+[L2-24];
		// if manually choose, use edtitext boxes
		if(customheadersOptChoice == "manuallyChoose"){
			newEditText = workCustomHeaders2.add('edittext', un, un);	
			newEditText.preferredSize = editMSml;
			newEditText.text = headerObject[L2].customHeader
			}
		if(customheadersOptChoice == "importList"){
			newEditText = workCustomHeaders2.add('dropdownlist', un, un, {items: mappingListArr});
			newEditText.preferredSize = editMSml
			}
		newEditText.enabled = false    
		newEditText.id = "customHeader"+[L2-24];	
		newCopyBtn = workCopyDefault2.add( 'button', un, ">");
		newCopyBtn.preferredSize = buttonSize1a
		newCopyBtn.enabled = false
		newCopyBtn.helpTip = useDefaultBtnTT
		newCopyBtn.id = "copyButton"+[L2-24];
		newCopyBtn.onClick = function(){
			var index = this.id.split("copyButton").join("")           
			workCustomHeaders2.children[index].text = workDefaultHeaders2.children[index].text 
			}
		} // end while(workDefaultHeaders2.children.length > 0)
	
	}

function addImageHeader(){
	// column 1
	while(imageDefaultHeaders1.children.length > 0){
		imageDefaultHeaders1.remove(0)
		}
	while(imageCopyDefault1.children.length > 0){
		imageCopyDefault1.remove(0)
		}
	while(imageCustomHeaders1.children.length > 0){
		imageCustomHeaders1.remove(0)
		}
   for(var i = 43; i < 60; i++){    
		newLabel = imageDefaultHeaders1.add('statictext', un, columnHeaders[i]);
		newLabel.preferredSize = editMSml;
		newLabel.id = "defaultHeader"+[i-43];          
		 // if manually choose, use edtitext boxes
		if(customheadersOptChoice == "manuallyChoose"){
			newEditText = imageCustomHeaders1.add('edittext', un, un);	
			newEditText.text = headerObject[i].customHeader
			}
		if(customheadersOptChoice == "importList"){
			newEditText = imageCustomHeaders1.add('dropdownlist', un, un, {items: mappingListArr});
			}
		newEditText.enabled = false
		newEditText.preferredSize = editMSml;
		newEditText.id = "customHeader"+[i-43];
		newCopyBtn = imageCopyDefault1.add( 'button', un, ">");
		newCopyBtn.enabled = false
		newCopyBtn.preferredSize = buttonSize1a
		newCopyBtn.helpTip = useDefaultBtnTT
		newCopyBtn.id = "copyButton"+[i-43]
		newCopyBtn.onClick = function(){
		var index = this.id.split("copyButton").join("")           
		imageCustomHeaders1.children[index].text = imageDefaultHeaders1.children[index].text 
		} 
	} // end while(imageDefaultHeaders1.children.length > 0)
	// column 2
	while(imageDefaultHeaders2.children.length > 0){
		imageDefaultHeaders2.remove(0)
		}
	while(imageCopyDefault2.children.length > 0){
		imageCopyDefault2.remove(0)
		}
	while(imageCustomHeaders2.children.length > 0){
		imageCustomHeaders2.remove(0)
		}
   for(var i = 60; i < 76; i++){    
		newLabel = imageDefaultHeaders2.add('statictext', un, columnHeaders[i]);
		newLabel.preferredSize = editMSml;
		newLabel.id = "defaultHeader"+[i-60];          
		 // if manually choose, use edtitext boxes
		if(customheadersOptChoice == "manuallyChoose"){
			newEditText = imageCustomHeaders2.add('edittext', un, un);	
			newEditText.text = headerObject[i].customHeader
			}
		if(customheadersOptChoice == "importList"){
			newEditText = imageCustomHeaders2.add('dropdownlist', un, un, {items: mappingListArr});
			}
		newEditText.enabled = false
		newEditText.preferredSize = editMSml;
		newEditText.id = "customHeader"+[i-60];
		newCopyBtn = imageCopyDefault2.add( 'button', un, ">");
		newCopyBtn.enabled = false
		newCopyBtn.preferredSize = buttonSize1a
		newCopyBtn.helpTip = useDefaultBtnTT
		newCopyBtn.id = "copyButton"+[i-60]
		newCopyBtn.onClick = function(){
		var index = this.id.split("copyButton").join("")           
		imageCustomHeaders2.children[index].text = imageDefaultHeaders2.children[index].text 
		} 
	} // end while(imageDefaultHeaders2.children.length > 0)
}

function addAdminSumHeader(){
	while(adminSumDefaultHeaders.children.length > 0){
		adminSumDefaultHeaders.remove(0)
		}
	while(adminSumCopyDefault.children.length > 0){
		adminSumCopyDefault.remove(0)
		}
	while(adminSumCustomHeaders.children.length > 0){
		adminSumCustomHeaders.remove(0)
		}
    for(var i = 76; i < 88; i++){    // 102
        newLabel = adminSumDefaultHeaders.add('statictext', un, columnHeaders[i]);
        newLabel.preferredSize = editMSml;
        newLabel.id = "defaultHeader"+[i-76];    
 // if manually choose, use edtitext boxes
if(customheadersOptChoice == "manuallyChoose"){
    newEditText = adminSumCustomHeaders.add('edittext', un, un);	
    newEditText.text = headerObject[i].customHeader
    }
if(customheadersOptChoice == "importList"){
    newEditText = adminSumCustomHeaders.add('dropdownlist', un, un, {items: mappingListArr});
    }
		newEditText.enabled = false
        newEditText.preferredSize = editMSml;
        newEditText.id = "customHeader"+[i-76];
        newCopyBtn = adminSumCopyDefault.add( 'button', un, ">");
		newCopyBtn.enabled = false
        newCopyBtn.preferredSize = buttonSize1a
        newCopyBtn.helpTip = useDefaultBtnTT
        newCopyBtn.id = "copyButton"+[i-76]
		newCopyBtn.onClick = function(){
			var index = this.id.split("copyButton").join("")           
			adminSumCustomHeaders.children[index].text = adminSumDefaultHeaders.children[index].text 
			}
		}
}		

function addTechHeader(){
	while(techHeaderLists.children.length > 0){
		techHeaderLists.remove(0)
		}
    for(var i = 88; i < 102; i++){    // 102
        newLabel = techHeaderLists.add('statictext', un, columnHeaders[i]);
        newLabel.preferredSize = editMSml;
        newLabel.id = "techHeader"+[i-88];		
		}
	}

	//// end of set headers window
	function setHeadersFunc(){
        headersOptionsWindow.hide()
        mainWindow.enabled = false	
        addWorkHeader();	
        addImageHeader();
        addAdminSumHeader();
        //addTechHeader();		
        toggleCustomHeaders()	
        headersWindow.show();		
        headersWindow.center();  
        headersWindow.layout.layout (true);
		importingPlt.hide()
        //   headersWindow.enabled = true
        }
	
 function clearCustomHeaders(){
	customHeadersArray = [];		
//	if(customheadersOptChoice == "importList"){	// TODO: right?
		//work
		// column 1
		for(var L1 = 1; L1 < workCustomHeaders1.children.length; L1++){
				val= workCustomHeaders1.children[L1].text = ""
			}
		// column 2
		for(var L2 = 0; L2 < workCustomHeaders2.children.length; L2++){
				val= workCustomHeaders2.children[L2].text = ""
			}
		//image
		// column 1
		for(var L3 = 0; L3 < imageCustomHeaders1.children.length; L3++){
				val= imageCustomHeaders1.children[L3].text = ""
			}
		// column 2
		for(var L4 = 0; L4 < imageCustomHeaders2.children.length; L4++){
				val= imageCustomHeaders2.children[L4].text = ""
			}
		//  admin/summary	
		for(var L5 = 0; L5 < adminSumCustomHeaders.children.length; L5++){
				val= adminSumCustomHeaders.children[L5].text = ""
			}
//		}
	}

function saveCustomHeaders(){
	customHeadersArray = [];		
	if(customheadersOptChoice == "importList"){	
		//work
		// column 1
		for(var L1 = 0; L1 < workCustomHeaders1.children.length; L1++){
			var val = ""
			if(workCustomHeaders1.children[L1].selection){
				val= workCustomHeaders1.children[L1].selection.text
				}
				customHeadersArray.push(val)
			}
		// column 2
		for(var L2 = 0; L2 < workCustomHeaders2.children.length; L2++){
			var val = ""
			if(workCustomHeaders2.children[L2].selection){
				val= workCustomHeaders2.children[L2].selection.text
				}
				customHeadersArray.push(val)
			}
		//image
		// column 1
		for(var L3 = 0; L3 < imageCustomHeaders1.children.length; L3++){
			var val = ""
			if(imageCustomHeaders1.children[L3].selection){
				val= imageCustomHeaders1.children[L3].selection.text
				}
				customHeadersArray.push(val)
			}
		// column 2
		for(var L4 = 0; L4 < imageCustomHeaders2.children.length; L4++){
			var val = ""
			if(imageCustomHeaders2.children[L4].selection){
				val= imageCustomHeaders2.children[L4].selection.text
				}
				customHeadersArray.push(val)
			}
		//  admin/summary	
		for(var L5 = 0; L5 < adminSumCustomHeaders.children.length; L5++){
			var val = ""
			if(adminSumCustomHeaders.children[L5].selection){
				val= adminSumCustomHeaders.children[L5].selection.text
				}
				customHeadersArray.push(val)
			}
		}
	if(customheadersOptChoice == "manuallyChoose"){
		// if no file name field is specified, show an alert  - required    
		if(workCustomHeaders1.children[0].text == ""){
            workCustomHeaders1.children[0].text = "File Name (required)"
            /*
			app.beep()
			alert("File name field is required")
			return false*/
			} 
		// if custom fields are selected and there is no path, show an alert
		/*if(buttonsChoice.customHeadersRb.value == true && !workCustomHeaders1.children[1].text){
			alert("You selected to use custom fields, but you didn't specify a file path.  This might cause a problem if you are importing to subfolders.\n\nIf you know what you doing (you probably do), keep going, otherwise, add a file path.")
			}*/
	//	customHeadersArray = [];
		// work column 1
		for(var L1 = 0; L1 < workCustomHeaders1.children.length; L1++){
			// get rid of any rogue "undefined" values
		   workCustomHeaders1.children[L1].text = workCustomHeaders1.children[L1].text.split(un).join("")
			customHeadersArray.push(workCustomHeaders1.children[L1].text)
			}
		// work column 2
		for(var L2 = 0; L2 < workCustomHeaders2.children.length; L2++){
			// get rid of any rogue "undefined" values
		   workCustomHeaders2.children[L2].text = workCustomHeaders2.children[L2].text.split(un).join("")
			customHeadersArray.push(workCustomHeaders2.children[L2].text)
			}
		// image column 1
		for(var L3 = 0; L3 < imageCustomHeaders1.children.length; L3++){
			imageCustomHeaders1.children[L3].text = imageCustomHeaders1.children[L3].text.split(un).join("")
		    customHeadersArray.push(imageCustomHeaders1.children[L3].text)
			}
		// image column 2
		for(var L4 = 0; L4 < imageCustomHeaders2.children.length; L4++){
			imageCustomHeaders2.children[L4].text = imageCustomHeaders2.children[L4].text.split(un).join("")
		    customHeadersArray.push(imageCustomHeaders2.children[L4].text)
			}
		//  admin/summary		
		for(var L5 = 0; L5 < adminSumCustomHeaders.children.length; L5++){
		   adminSumCustomHeaders.children[L5].text = adminSumCustomHeaders.children[L5].text.split(un).join("")
			customHeadersArray.push(adminSumCustomHeaders.children[L5].text)
			}
		/*for(var L4 = 0; L4 < techHeaderLists.children.length; L4++){
				customHeadersArray.push(techHeaderLists.children[L4].text)
			}*/
		} // end if(customheadersOptChoice == "manuallyChoose")
	
	 for (var L5 = 0; L5 < customHeadersArray.length; L5++){
		headerObject[L5].customHeader = customHeadersArray[L5]
		}		
	headersWindow.hide();
    mainWindow.enabled = true;
    }

	// check to see if the folder of images specified exists
		function testImportImagesFolder(){
			var selectedFolder = Folder(imageLoc.text.split(" ").join("%20"));			
			if (imageLoc.text && selectedFolder.exists == false){
				importImageFolderOK = false;
				imageLocAlert.visible = true;
				}
			else if (imageLoc.text && selectedFolder.exists == true){
				importImageFolderOK = true;
				imageLocAlert.visible = false;
				}
			toggleImportBtn();
			}		
				
		// check to see if the .txt file folder specified exists
		function testTextFileExists(){
			// get just the directory
			var textFile = File(dataSource.text.split(" ").join("%20"));
			if (dataSource.text && textFile.exists == false){
				importTextFileOK = false;
				dataSourceFileAlert.visible = true;
				}
			else if (dataSource.text && textFile.exists == true){
				importTextFileOK = true;
				dataSourceFileAlert.visible = false;
				}
			toggleImportBtn();
			}

		function toggleImportBtn(){
			if (importImageFolderOK == true && importTextFileOK == true ){
				importBtn.enabled = true;
				}
			else{
				 importBtn.enabled = false;
				}
			}
		
		  // test to see if the paths entered by user exist
		 imageLoc.addEventListener('changing',function(){testImportImagesFolder()});
		 dataSource.addEventListener('changing',function(){testTextFileExists()});
		 
          // Import button
          importBtn = importPanel.add('button', undefined, "Import");
          importBtn.preferredSize = [120, 35];
          importBtn.onClick = importFromFile;
            
		// Create a text file on the desktop with only the headers.  This can be used as a template in Excel to create properly formatted text for the import function
		function createTemplate(){
			var vraTemplate = new File (desktop+"VRA_import_default template.txt")                
			vraTemplate.encoding = "UTF8";
			vraTemplate.open ("w", "TEXT", "ttxt");	

			// Loop through array of headers (properties) and write them to the .txt file
			for (var L1 = 0; L1 < columnHeaders.length; L1++) vraTemplate.write (columnHeaders[L1] + "\t");

			// Close the file  "VRA_import_template.txt"
			vraTemplate.close();

			Window.alert ("A new file named:\n\nVRA_import_default template.txt\n\nhas been created on your desktop.", "Success!")
			}
			
		// Cancel button
		cancelBtn = mainWindow.add('button', undefined, "Cancel");
		cancelBtn.minimumSize = buttonSize5
		cancelBtn.onClick = function(){
            var appDataPlgnSet = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet); // ~/AppData/Roaming/VRA_Import_Export/Options/settings.txt
            appDataPlgnSet.open ("w", "TEXT", "ttxt");
            appDataPlgnSet.write (exportWhich.folderRb.value  + "|");
            appDataPlgnSet.write (exportWhich.subfoldersCb.value  + "|");  
            appDataPlgnSet.write (exportWhich.thumbsRb.value + "|");
            appDataPlgnSet.write (exportOptions.datesCb.value + "|");
            appDataPlgnSet.write (dataSource.text + "|");
            appDataPlgnSet.write (writeOptions.appendRb.value+ "|");
            appDataPlgnSet.write(writeOptions.overwriteRb.value + "|");
            appDataPlgnSet.write (IgnoreExtCb.value+ "|");
            appDataPlgnSet.write (fillSubjCb.value+ "|");
            appDataPlgnSet.write (fillCptCb.value+ "|");     
            appDataPlgnSet.write (addLabelCb.value+ "|");
            appDataPlgnSet.write (exportOptionsLfCb.value+"|");
            appDataPlgnSet.write (exportChoice+"|");
            appDataPlgnSet.write (exportWhich.folderEt.text + "|");
            appDataPlgnSet.write (imageLoc.text+ "|");
            appDataPlgnSet.write (imageLocSubfoldersCb.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.Path.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.Name.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.enabled+ "|");
            appDataPlgnSet.write (IgnoreExtCb.enabled+ "|");
            appDataPlgnSet.write (fillTitleCb.value+ "|");
			appDataPlgnSet.write (customHeadersArray.join(",") + "|");
			appDataPlgnSet.write (buttonsChoice.defaultHeadersRb.value + "|");
			appDataPlgnSet.write (buttonsChoice.customHeadersRb.value );
            appDataPlgnSet.close();
            // close hte main UI window   
            mainWindow.close();     
			}
 
     // if file 'appDataFwdSlash/VRA_Import_Export/Options/settings.txt' exists, read settings and apply to dialog
	 // ~/AppData/Roaming/VRA_Import_Export/Options/settings.txt
	 // C:\Users\Computer User\AppData\Roaming\VRA_Import_Export\Options
     var appDataPlgnSetBkSlash = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet);
     if (appDataPlgnSetBkSlash.exists == true){
          appDataPlgnSetBkSlash.open ('r');
          var pluginSettingsArray = appDataPlgnSetBkSlash.read().split ('|');
          appDataPlgnSetBkSlash.close();
		try{           
			if (pluginSettingsArray[1] == "true") exportWhich.subfoldersCb.value = true;           	
			if (pluginSettingsArray[3] == "false") exportOptions.datesCb.value = false;
			if (pluginSettingsArray[4]) dataSource.text = pluginSettingsArray[4];
			if (pluginSettingsArray[5] == "true") writeOptions.appendRb.value = true;
			if (pluginSettingsArray[6] == "true") writeOptions.overwriteRb.value = true;
			if (pluginSettingsArray[7] == "true") IgnoreExtCb.value = true; 
			if (pluginSettingsArray[8] == "true") fillSubjCb.value = true;
			if (pluginSettingsArray[9] == "true") fillCptCb.value = true; 
			if (pluginSettingsArray[10] == "true") addLabelCb.value = true;
			if (pluginSettingsArray[11] == "false") exportOptionsLfCb.value = false;
			exportChoice = pluginSettingsArray[12];        
			 if (pluginSettingsArray[12] == "folder") exportWhich.folderRb.value = true;
			 if (pluginSettingsArray[12] == "thumbs") exportWhich.thumbsRb.value = true;
			if (pluginSettingsArray[13]) exportWhich.folderEt.text = pluginSettingsArray[13];
			if (pluginSettingsArray[14]) imageLoc.text = pluginSettingsArray[14];
			if (pluginSettingsArray[15] == "true") imageLocSubfoldersCb.value = true;   
			if (pluginSettingsArray[16] == "true") dataSourceOptions.Path.value = true;
			if (pluginSettingsArray[17] == "true") dataSourceOptions.Name.value = true;
			if (pluginSettingsArray[18] == "false") dataSourceOptions.enabled = false;
			if (pluginSettingsArray[19] == "false") IgnoreExtCb.enabled = false;  
			if (pluginSettingsArray[20] == "true") fillTitleCb.value = true;
			if (pluginSettingsArray[21]) customHeadersArray = pluginSettingsArray[21].split(",");
                for (var L1 = 0; L1 < customHeadersArray.length; L1++){
                    headerObject[L1].customHeader = customHeadersArray[L1]
                    }
			if (pluginSettingsArray[22] == "true") buttonsChoice.defaultHeadersRb.value = true;
			if (pluginSettingsArray[22] == "true") setHeaders.text = "Using Default Field Names";
			if (pluginSettingsArray[23] == "true") buttonsChoice.customHeadersRb.value = true;
			if (pluginSettingsArray[23] == "true") setHeaders.text = "Using Custom Field Names";
			}
          catch(pluginSettingsError){
               if (appDataPlgnSetBkSlash.exists == true) appDataPlgnSetBkSlash.remove();
          }
     }
// get current Bridge folder and file paths to automatically fill form
        if(app.document.visibleThumbnails == true){
            var slicePathIndex = app.document.visibleThumbnails[0].spec.toString().lastIndexOf ("/")
            var path = app.document.visibleThumbnails[0].spec.toString().substr(0,slicePathIndex+1).split("%20").join(" ")
            exportWhich.folderEt.text = path
            imageLoc.text = path
            }
		// get current Bridge folder and file paths to automatically fill form
		if(app.document.visibleThumbnails){
			 var slicePathIndex = app.document.visibleThumbnails[0].spec.toString().lastIndexOf ("/")
			 var path = app.document.visibleThumbnails[0].spec.toString().substr(0,slicePathIndex+1).split("%20").join(" ")
			 exportWhich.folderEt.text = path
			 imageLoc.text = path		     
			}
		if (hardDriveCheck == null) var hardDriveCheck = hardDrive;
		toggleExportWhich();
		testExportImagesFolder();
		testImportImagesFolder();
		testTextFileExists();
		//file path help tips
		exportWhich.folderEt.helpTip = exportWhich.folderEt.text+"\n\n"+imageFolderPath
		imageLoc.helpTip = imageLoc.text+"\n\n"+imageFolderPath
		dataSource.helpTip = dataSource.text+"\n\n"+textFilePath
            // open the window
            mainWindow.show(); 
         } // main UI window - brace 1 close
    ///////////////////////////////////////////////////////////
  ////////// END MAIN WINDOW //////////
////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////
  ////////// MAIN WINDOW FUNCTIONS //////////
///////////////////////////////////////////////////////////////////////////
// navigation toggle
var navBtnsArr = [wrkBtn,imgBtn,admSumBtn]
var navBtnsTextArr = ["Work","Image","Admin/Summary"]
var fieldColArr = [workHeaderGrp,imageHeaderGrp,adminSumHeaderGrp]
var lastViewedHeadersPanel = "Work";
function toggleNavBtns(){
    try{
	for (var L1 = 0; L1 < navBtnsTextArr.length; L1++){
		if(this.text == navBtnsTextArr[L1]+navBtnsIndentArr[L1] || lastViewedHeadersPanel == navBtnsTextArr[L1]){
            fieldColArr[L1].visible = true
            navBtnsArr[L1].text = navBtnsIndentArr[L1]+navBtnsTextArr[L1]+rightArrow
		//	navBtnsArr[L1].alignment = 'right'	
			}
		else{
            fieldColArr[L1].visible = false
            navBtnsArr[L1].text = navBtnsTextArr[L1]+navBtnsIndentArr[L1]
		//	navBtnsArr[L1].alignment = 'left'
			}
		}
     }
    catch(e){}
	lastViewedHeadersPanel = this.text
	headersWindow.layout.layout (true)
	}

function toggleCustomHeaders(){
		//	if (setHeaders.text = "Using Custom Headers"){
	if (buttonsChoice.customHeadersRb.value == true){
		// work column 1
		for(var L1 = 0; L1<workDefaultHeaders1.children.length; L1++){
			workDefaultHeaders1.children[L1].enabled= false
			}
		for(var L1a = 0; L1a<workCopyDefault1.children.length; L1a++){
			workCopyDefault1.children[L1a].enabled= true
			}
		for(var L1b = 0; L1b<workCustomHeaders1.children.length; L1b++){
			workCustomHeaders1.children[L1b].enabled= true
			}
		// work column 2
		for(var L2 = 0; L2<workDefaultHeaders2.children.length; L2++){
			workDefaultHeaders2.children[L2].enabled= false
			}
		for(var L2a = 0; L2a<workCopyDefault2.children.length; L2a++){
			workCopyDefault2.children[L2a].enabled= true
			}
		for(var L2b = 0; L2b<workCustomHeaders2.children.length; L2b++){
			workCustomHeaders2.children[L2b].enabled= true
			}	
		// disable File Name becasue it's required and should not be changed
		//workCustomHeaders1.children[0].enabled = false
		// image column 1
		for(var L3 = 0; L3<imageDefaultHeaders1.children.length; L3++){
			imageDefaultHeaders1.children[L3].enabled= false
			}
		for(var L3a = 0; L3a<imageCopyDefault1.children.length; L3a++){
			imageCopyDefault1.children[L3a].enabled= true
			}
		for(var L3b = 0; L3b<imageCustomHeaders1.children.length; L3b++){
			imageCustomHeaders1.children[L3b].enabled= true
			}
		// image column 2
		for(var L4 = 0; L4<imageDefaultHeaders2.children.length; L4++){
			imageDefaultHeaders2.children[L4].enabled= false
			}
		for(var L4a = 0; L4a<imageCopyDefault2.children.length; L4a++){
			imageCopyDefault2.children[L4a].enabled= true
			}
		for(var L4b = 0; L4b<imageCustomHeaders2.children.length; L4b++){
			imageCustomHeaders2.children[L4b].enabled= true
			}
		//  admin/summary
		for(var L5 = 0; L5<adminSumDefaultHeaders.children.length; L5++){
			adminSumDefaultHeaders.children[L5].enabled= false
			}
		for(var L5a = 0; L5a<adminSumCopyDefault.children.length; L5a++){
			adminSumCopyDefault.children[L5a].enabled= true
			}
		for(var L5b = 0; L5b<adminSumCustomHeaders.children.length; L5b++){
			adminSumCustomHeaders.children[L5b].enabled= true
			}
		setHeaders.text = "Using Custom Field Names"
		}
	//	if (setHeaders.text = "Using Default Headers"){	
	if (buttonsChoice.defaultHeadersRb.value == true){
		// work column 1
		for(var L1 = 0; L1<workDefaultHeaders1.children.length; L1++){
			workDefaultHeaders1.children[L1].enabled= true
			}
		for(var L1a = 0; L1a<workCopyDefault1.children.length; L1a++){
			workCopyDefault1.children[L1a].enabled= false
			}
		for(var L1b = 0; L1b<workCustomHeaders1.children.length; L1b++){
			workCustomHeaders1.children[L1b].enabled= false
			}
		// work column 2
		for(var L2 = 0; L2<workDefaultHeaders2.children.length; L2++){
			workDefaultHeaders2.children[L2].enabled= true
			}
		for(var L2a = 0; L2a<workCopyDefault2.children.length; L2a++){
			workCopyDefault2.children[L2a].enabled= false
			}
		for(var L2b = 0; L2b<workCustomHeaders2.children.length; L2b++){
			workCustomHeaders2.children[L2b].enabled= false
			}
		// image column 1
		for(var L3 = 0; L3<imageDefaultHeaders1.children.length; L3++){
			imageDefaultHeaders1.children[L3].enabled= true
			}
		for(var L3a = 0; L3a<imageCopyDefault1.children.length; L3a++){
			imageCopyDefault1.children[L3a].enabled= false
			}
		for(var L3b = 0; L3b<imageCustomHeaders1.children.length; L3b++){
			imageCustomHeaders1.children[L3b].enabled= false
			}
		// image column 2
		for(var L4 = 0; L4<imageDefaultHeaders2.children.length; L4++){
			imageDefaultHeaders2.children[L4].enabled= true
			}
		for(var L4a = 0; L4a<imageCopyDefault2.children.length; L4a++){
			imageCopyDefault2.children[L4a].enabled= false
			}
		for(var L4b = 0; L4b<imageCustomHeaders2.children.length; L4b++){
			imageCustomHeaders2.children[L4b].enabled= false
			}	
		//  admin/summary
		for(var L5 = 0; L5<adminSumDefaultHeaders.children.length; L5++){
			adminSumDefaultHeaders.children[L5].enabled= true
			}
		for(var L5a = 0; L5a<adminSumCopyDefault.children.length; L5a++){
			adminSumCopyDefault.children[L5a].enabled= false
			}
		for(var L5b = 0; L5b<adminSumCustomHeaders.children.length; L5b++){
			adminSumCustomHeaders.children[L5b].enabled= false
			}	
		setHeaders.text = "Using Default Field Names"
		} 
        if (customheadersOptChoice == "importList" && buttonsChoice.customHeadersRb.value == true){
            workCopyDefault1.visible = false
            workCopyDefault2.visible = false
            imageCopyDefault1.visible = false
            imageCopyDefault2.visible = false
            adminSumCopyDefault.visible = false
            }
        else{
            workCopyDefault1.visible = true
            workCopyDefault2.visible = true
            imageCopyDefault1.visible = true
            imageCopyDefault2.visible = true
            adminSumCopyDefault.visible = true
            }
	}
    ///////////////////////////////////////////////////////////////////////////////////
  ////////// END MAIN WINDOW FUNCTIONS //////////
/////////////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////
 ////////// EXPORT //////////
//////////////////////////////////////
	// check for valid file type i.e. jpg, jpeg, tif, etc.
    function testFileExtension(file) {
       return file instanceof File &&
          file.name.match(/\.(bmp|dng|gif|jpe?g|pdf|png|psd|tiff?|xmp)$/i) != null;
        }  
	// check that filename does not begin with "."
	function testFilePrefix(file) {
       return file instanceof File &&
          file.name.substring(0, 1) != "." == true;
        }

	// Progress bar for locating files
	var locateFilesProgress = new Window ('palette', "Exporting Metadata");
	locateFilesProgress.body = locateFilesProgress.add('group', undefined);
	locateFilesProgress.preferredSize = [300,100];
	locateFilesProgress.alignChildren = 'center';
	locateFilesProgress.message = locateFilesProgress.add('statictext', undefined, "Locating Files...");
   
   // Beginning of data Export Function
     // Extract and write metadata to a .txt. file
     function exportToFile(){ 
         	  { // export brace 1 open
		   if(exportWhich.thumbsRb.value == true && app.document.selections.length == 0){
			 app.beep();
			 Window.alert("You must select at least one thumbnail");
			 return false
			}
		   else{
			// Open the Save dialog to choose a file name and directory for the export file
              caption = 'VRA panel metadata export'
			var dataExport = File.saveDialog( caption,  "TXT  Files:*.txt" );             
			dataExport.encoding = "UTF8";
			dataExport.open ('w', 'XLS', 'XCEL');   				
			// Create empty objects to store pass/fail data during export
			var filePass = 0;
			var fileFail = 0;
			var fileFailArr = [];
			var couldNotOpen = [];
			var propFail = 0;
            var customHeadersExported = [];
       if (dataExport){  
        var allFiles = [];
        var selectedFolder = Folder(exportWhich.folderEt.text.split(" ").join("%20"));
        var appDataPlgnSet = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet);
        appDataPlgnSet.open ("w", "TEXT", "ttxt");
            appDataPlgnSet.write (exportWhich.folderRb.value  + "|");
            appDataPlgnSet.write (exportWhich.subfoldersCb.value  + "|");  
            appDataPlgnSet.write (exportWhich.thumbsRb.value + "|");
            appDataPlgnSet.write (exportOptions.datesCb.value + "|");
            appDataPlgnSet.write (dataSource.text + "|");
            appDataPlgnSet.write (writeOptions.appendRb.value+ "|");
            appDataPlgnSet.write(writeOptions.overwriteRb.value + "|");
            appDataPlgnSet.write (IgnoreExtCb.value+ "|");
            appDataPlgnSet.write (fillSubjCb.value+ "|");
            appDataPlgnSet.write (fillCptCb.value+ "|");     
            appDataPlgnSet.write (addLabelCb.value+ "|");
            appDataPlgnSet.write (exportOptionsLfCb.value+"|");
            appDataPlgnSet.write (exportChoice+"|");
            appDataPlgnSet.write (exportWhich.folderEt.text + "|");
            appDataPlgnSet.write (imageLoc.text+ "|");
            appDataPlgnSet.write (imageLocSubfoldersCb.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.Path.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.Name.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.enabled+ "|");
            appDataPlgnSet.write (IgnoreExtCb.enabled+ "|");
            appDataPlgnSet.write (fillTitleCb.value+ "|");
			appDataPlgnSet.write (customHeadersArray+ "|");
			appDataPlgnSet.write (buttonsChoice.defaultHeadersRb.value+ "|");
			appDataPlgnSet.write (buttonsChoice.customHeadersRb.value);
            appDataPlgnSet.close();
        // close the main user interface window before running the export
        mainWindow.hide();			     

	// open selectedFolder add the path of every file found to the 'allFiles' array. this will be the list of files to be exported
	function getFolder(selectedFolder) {
		var allFilesList = selectedFolder.getFiles();
		for (var L1 = 0; L1 < allFilesList.length; L1++) {
			var myFile = allFilesList[L1];
				if (myFile instanceof File && testFileExtension(myFile) == true && testFilePrefix(myFile) == true) {
				allFiles.push(myFile); 
				}
			}
		}

	// open selectedFolder and all subfolders an add the path of every file found to the 'allFiles' array. this will be the list of files to be exported
	function getSubFolders(selectedFolder) {
		 var allFilesList = selectedFolder.getFiles();
		 for (var L1 = 0; L1 < allFilesList.length; L1++) {		 	 
			  var myFile = allFilesList[L1];
			  if (myFile instanceof Folder){
				   getSubFolders(myFile);
			  }
			  else if (myFile instanceof File && testFileExtension(myFile) == true && testFilePrefix(myFile) == true) {
				   allFiles.push(myFile); 
				  }
			 }  
		}

	// if "Include subfolders" is not checked, only read the files in the selected folder
	if (exportWhich.subfoldersCb.value == false){
		locateFilesProgress.show();
		getFolder(selectedFolder);
		locateFilesProgress.hide();
		}

	// if "Include subfolders" is checked, read all the files in the selected folder and its subfolders
	if (exportWhich.subfoldersCb.value == true){
		locateFilesProgress.show();
		getSubFolders(selectedFolder);
		locateFilesProgress.hide();
		}

	  if (exportWhich.folderRb.value == true) var Thumb = allFiles;
	  if (exportWhich.thumbsRb.value == true) var Thumb = app.document.selections;
			// progress bar window to show files are exporting
			var exportProgress = new Window ("palette {text: ' " + plgnName + "  " + spot + "  (Exporting VRA Data)', bounds: [0,0,500,30], X: Progressbar {bounds: [0,0,500,30]}};");
			// todo: why was this handeled separately?  is there an issue with custom fields, file path, and sub-folders? 
			/*
			if(headerObject[0].customHeader.length > 0){
						dataExport.write (headerObject[0].customHeader + "\t")
						}
					else{
						dataExport.write (headerObject[0].header + "\t")
						}
					*/
			// begin exporting data to the text file
			// loop through array of headers (properties) and write them to the .txt file
			for (var L1 = 0; L1 < headerObject.length; L1++){
                if (buttonsChoice.customHeadersRb.value == true){
                    if(headerObject[L1].customHeader.length > 0){
                        dataExport.write (headerObject[L1].customHeader + "\t");
					customHeadersExported.push(headerObject[L1].customHeader)
                        }
                    }
                else{
                    dataExport.write (headerObject[L1].header + "\t");
                    }
                }
			// loop through files, read XMP property data and write it to "^VRA_Data.txt"
			for (var L2 = 0; L2 < Thumb.length; L2++){
            // Display exorting progress bar if there are more than 50 images
			  if (Thumb.length > 50){
				   exportProgress.X.value = (L2 / Thumb.length) * 100;
				   exportProgress.center();
				   exportProgress.show();
				}
			if (Thumb[L2]){
             // get just the file name from allFiles so we can compare it to the file name in the text file
			 var splicePathIndex = Thumb[L2].toString().lastIndexOf ("/")
			 /* // TODO: disabled becasue Mac requires ".lastIndexOf ("/")" the same as Windows - use new doubled version below?
				 if (Folder.fs == 'Windows'){
					var splicePathIndex = Thumb[L2].toString().lastIndexOf ("/")
					}
				else{  
					var splicePathIndex = Thumb[L2].toString().lastIndexOf ("\\")
                       var splicePathIndex = Thumb[L2].toString().lastIndexOf ("/")
					}
				*/
				// just the file directory
				var spliceDirectory = Thumb[L2].toString().substr(0,splicePathIndex+1).split("%20").join(" ");
				// just the file name
				if (exportWhich.folderRb.value == true) var spliceName = Thumb[L2].toString().slice(splicePathIndex+1).split("%20").join(" ");
                  if (exportWhich.thumbsRb.value == true) var spliceName = Thumb[L2].name.split ("%20").join (' ');

				// overall try/catch for each image. If read passes, 1 is added to filePass variable. If read fails, catch error adds 1 to fileFail variable  and file name to fileFailArr
				try
				{		
				  // Get the file
				  if (exportWhich.folderRb.value == true) var singleFile = Thumb[L2];
				  if (exportWhich.thumbsRb.value == true) var  singleFile = Thumb[L2].spec;
                  // Create an XMPFile
                  // try to open file. if it fails, save file path in error log
                    try{
                    // if file is an .xmp sidecar - read the xmp directly to an XMPMeta Object
                    if( singleFile.name.match(/\.xmp/i) != null){
                        var xmpFile = Folder (File(singleFile.fsName)); 
                        xmpFile.open('r')
					xmpFile.encoding = "UTF8";	
                        var xmpData = new XMPMeta(xmpFile.read()); 									
                        xmpFile.close()
                        }
                    else{
                        // if file is not an .xmp sidecar pull XMP from file
                        var xmpFile = new XMPFile(singleFile.fsName, XMPConst.UNKNOWN, XMPConst.OPEN_FOR_READ);
										  	xmpFile.encoding = "UTF8 BOM";
                        // convert to xmp
                        var xmpData = xmpFile.getXMP();
                        }
                    }
                    catch(couldNotOpenError){}
				// write return to start file properties
				dataExport.write ('\r');
				// Export image file name
				dataExport.write (spliceName);

				// Export file directory
				 if (buttonsChoice.customHeadersRb.value == true){
					 if(headerObject[1].customHeader.length > 0){  
						 dataExport.write ('\t' + spliceDirectory);
						 }
					 }
				 else{
					dataExport.write ('\t' + spliceDirectory);
					 }						
				
// Run export functions
for (var L1 = 0; L1 < headerObject.length; L1++){
	if(headerObject[L1].type == 'text' || headerObject[L1].type == 'boolean'){
		try{
			// customHeaders logic
            if (buttonsChoice.customHeadersRb.value == true){
                    if(headerObject[L1].customHeader.length > 0){                            
                        prop = xmpData.getProperty(headerObject[L1].namespace, headerObject[L1].path);
                        if (prop){
                            if (exportOptionsLfCb.value == true){
                                dataExport.write ("\t" + prop.toString().split("\n").join("; ").split("\r").join("; ").split("\t").join("; "));
                                }
                            else{
                                dataExport.write ("\t" + prop.toString().split("\n").join("(LF)").split("\r").join("(CR)").split("\t").join("(HT)"));
                                }
                            }
                        else{
                            dataExport.write ("\t");
                            }
                        }                
        		} // end if (buttonsChoice.customHeadersRb.value == true)
            else{                         
                    prop = xmpData.getProperty(headerObject[L1].namespace, headerObject[L1].path);
                    if (prop){
                        if (exportOptionsLfCb.value == true){
                            dataExport.write ("\t" + prop.toString().split("\n").join("; ").split("\r").join("; ").split("\t").join("; "));
                            }
                        else{
                            dataExport.write ("\t" + prop.toString().split("\n").join("(LF)").split("\r").join("(CR)").split("\t").join("(HT)"));
                            }
                        }
                    else{
                        dataExport.write ("\t");
                        }
                    } // end else
            } // end try
			catch(propFail){propFail++}
			}

	if(headerObject[L1].type == 'date'){
		try{
            if (buttonsChoice.customHeadersRb.value == true){
                if(headerObject[L1].customHeader.length > 0){  
                prop = xmpData.getProperty (headerObject[L1].namespace, headerObject[L1].path);
                if (prop){
                    if (exportOptions.datesCb .value == true) var prop = "_" + prop;                                      
                    dataExport.write ('\t' + prop);
                    }
                else{
                    dataExport.write ('\t');
                    }
                }
            }
        else{
            prop = xmpData.getProperty (headerObject[L1].namespace, headerObject[L1].path);
			if (prop){
				if (exportOptions.datesCb .value == true) var prop = "_" + prop;                                      
				dataExport.write ('\t' + prop);
				}
			else{
				dataExport.write ('\t');
				}
			}
            }
          catch(propFail){propFail++}    
		}

	if(headerObject[L1].type == 'seq' || headerObject[L1].type == 'bag' || headerObject[L1].type == 'bagDcSubject' || headerObject[L1].type == 'langAlt' || headerObject[L1].type == 'langAltDcTitle' || headerObject[L1].type == 'langAltDcDescription'){
		try{
            if (buttonsChoice.customHeadersRb.value == true){
                if(headerObject[L1].customHeader.length > 0){  
                    var count = xmpData.countArrayItems(headerObject[L1].namespace, headerObject[L1].path);
                    var arString = "";               
                if(count > 0){                   
                   for(var L1a = 1;L1a <= count;L1a++){
                         try{
                        arString += xmpData.getArrayItem(headerObject[L1].namespace, headerObject[L1].path, L1a);
                        if(L1a < count) arString += '; ';
                        }
                        catch(propFail){
                            var arString = "";
                            }
                        }
                    }      
                    if (exportOptionsLfCb.value == true){
                        dataExport.write ("\t" + arString.split("\n").join("; ").split("\r").join("; ").split("\t").join("; "));
                        }
                    else{
                        dataExport.write ("\t" + arString.split("\n").join("(LF)").split("\r").join("(CR)").split("\t").join("(HT)"));
                        }
                    }
                }
            else{
                var count = xmpData.countArrayItems(headerObject[L1].namespace, headerObject[L1].path);
                    var arString = "";
                     if(count > 0){   
                        for(var L1a = 1;L1a <= count;L1a++){
                            try{
                                arString += xmpData.getArrayItem(headerObject[L1].namespace, headerObject[L1].path, L1a);
                                if(L1a < count) arString += '; ';
                                }
                            catch(propFail){
                                var arString = "";
                                }
                            }
                        }
                        if (exportOptionsLfCb.value == true){
                            dataExport.write ("\t" + arString.split("\n").join("; ").split("\r").join("; ").split("\t").join("; "));
                            }
                        else{
                            dataExport.write ("\t" + arString.split("\n").join("(LF)").split("\r").join("(CR)").split("\t").join("(HT)"));
                            }
                        }
                    }		
			catch(propFail){propFail++}          
			}		
	} // end
				// Technical properties
                function exportText (namespace,path){
					try{
						prop = xmpData.getProperty (namespace,path);
						if (prop){
							dataExport.write ('\t' + prop);
							}
						else{
							dataExport.write ('\t');
							}
						}
					catch(propFail){propFail++}
					}	
				// Image File Created Date
				{
					try  {
						prop = singleFile.created;   							
						var fullDate = new Date (prop);
						var month = fullDate.getMonth() + 1;
						if (month.toString().length < 2)
						{
						month = "0"+month;
						} 
						var day = fullDate.getDate();
						if (day.toString().length < 2)
						{
						day = "0"+day;
						}
						var year = fullDate.getFullYear();
						var time = fullDate.toTimeString().split(" GMT").join("");
						time= time.substr(0,10) + ":" + time.substr(10)
						var display = year+"-"+month+"-"+day+"T"+time                 
						dataExport.write ("\t" + display); 
						}
					catch(propFail){propFail++}
				}                 

				// File Modified Date
				{
				try  {
					prop = singleFile.modified;                       
					var fullDate = new Date (prop);
					 var month = fullDate.getMonth() + 1;
					 if (month.toString().length < 2)
					{
						month = "0"+month;
					} 
					 var day = fullDate.getDate();
					   if (day.toString().length < 2)
					{
						day = "0"+day;
					}
					var year = fullDate.getFullYear();
					var time = fullDate.toTimeString().split(" GMT").join("");
					time= time.substr(0,10) + ":" + time.substr(10)
					var display = year+"-"+month+"-"+day+"T"+time                 
					dataExport.write ("\t" + display);   
					  }
			   catch(propFail){propFail++}
				}
						
			exportText (XMPConst.NS_DC, "format");   // TODO: find way to read directly from file

			// Export File Size (bytes)
			{
				try {
				   prop =  singleFile.length;                                
					var sizes = ["Bytes", "KB", "MB", "GB", "TB"];
					var i = parseInt(Math.floor(Math.log(prop) / Math.log(1024)));
					if (i == 0){
						prop = prop + " " + sizes[i];
						}
					else{
						prop = (prop / Math.pow(1024, i)).toFixed(1) + " " + sizes[i];
						}
					   dataExport.write ("\t" + prop);
				   }
				catch(propFail){propFail++}
				}
						  
			exportText (XMPConst.NS_EXIF, "PixelXDimension"); // TODO: find way to read directly from file
			exportText (XMPConst.NS_EXIF, "PixelYDimension"); // TODO: find way to read directly from file
			exportText (XMPConst.NS_TIFF, "BitsPerSample[1]"); // TODO: find way to read directly from file
			exportText (XMPConst.NS_TIFF, "Compression"); // TODO: find way to read directly from file

			// Export TIFF XResolution
			{  
				try  {
					Res = xmpData.getProperty( XMPConst.NS_TIFF, "XResolution") // TODO: find way to read directly from file
					// separate the value before the "/" from the value after it to do division
					var forwardSlashIndex = Res.toString().lastIndexOf ("/")
					// value before the "/"
					var pixels = Res.toString().substr(0,forwardSlashIndex);
					// value after the "/"
					var perInch = Res.toString().slice(forwardSlashIndex+1);
					// divide pixels by perInch and round to nearest integer
					prop = Math.round (pixels/perInch)

					if (prop){
						dataExport.write ("\t" + prop+" ppi");
						}
					else{
						dataExport.write ("\t");
						}
					}
				catch(propFail){propFail++}
				}   

			exportText (XMPConst.NS_TIFF, "Make");
			exportText (XMPConst.NS_TIFF, "Model");
			exportText (XMPConst.NS_TIFF, "Software");

			// Export PHOTOSHOP ColorMode
			{
				try {
					prop = xmpData.getProperty (XMPConst.NS_PHOTOSHOP, "ColorMode") // TODO: find way to read directly from file
					var mode = ["Bitmap", "Gray scale", "Indexed colour", "RGB colour", "CMYK colour", "Multi-channel", "Duotone", "LAB colour"];               
					if (prop){
						dataExport.write ("\t" + mode[prop]);
						}
					else{
						dataExport.write ("\t");
						}     
					}
				catch(propFail){propFail++}
				} 
							  
				// Export PHOTOSHOP ICCProfile (Color Profile)
				exportText (XMPConst.NS_PHOTOSHOP, "ICCProfile"); // TODO: find way to read directly from file

				// Export EXIF ColorSpace
				{
					try  {
						prop = xmpData.getProperty (XMPConst.NS_EXIF, "ColorSpace");
						var spec = ["1", "FFFF.H", "65535", "Other"]; 
						var label = ["sRGB", "Uncalibrated", "Uncalibrated", "reserved"];
						if (prop){
							for (var L1 = 0; L1 < spec.length; L1++){
								if (prop == spec[L1]){                                      
									dataExport.write ("\t" + label[L1]);
									}
								}
							}        
						else{
							dataExport.write ("\t");
							}
						}
					catch(propFail){propFail++}
					}

					// fail check  
				  if (propFail == 0)
						{
							filePass++;
						}
					} // End of overall try/catch for each image
				
				// outer fail check
				catch(fileFailArrError){
					fileFailArr.push(Thumb[L2].name.split ("%20").join (" "));
					} 
				} // end of  loop: if (Thumb[L2]){...
			}  // end of loop: for (var L2 = 0; L2 < Thumb.length; L2++){...

	/*		// TODO: is this ever used?  where is "var W" used after it is created here?
            var W = "";
            if (hardDriveCheck != hardDrive){
                if (Folder.fs == "Windows"){
                    var X = hardDriveCheck.split ("/").join ("\\");
                    var Y = X.substring (2);
                    if (X.split ("\\")[0] == "~") var Z = "~\\";
                    else var Z = X.substring (1,2).toUpperCase() + ":";
                    }
                else {
                    var X = hardDriveCheck;
                    var Y = X.substring (1);
                    if (X.split ("/")[0] == "~") var Z = "~";
                    else var Z = "/";
                    }
                var W = "\n" + spot + "  Current Folder:\n" + spot + "  " + Z + Y;
                }
          */
            } // end of 'Create and open the export file so it can recieve data'
        } // close brace 1 end of  if(exportWhich.thumbsRb.value == true && app.document.selections.length == 0)	
		//  Hide exorting progress bar
			exportProgress.hide()
		// Show report that extraction is complete with directory path of .txt file
		var textFilePath = dataExport.toString().split ("%20").join (" ").split("/").join ("\\");
		var complete = new Window("dialog", "Export Complete");
        complete.spacing = 3;
		complete.alignChildren ='center';		
		complete.header = complete.add('statictext', undefined, "Success!");
        complete.header.preferredSize = [400, 20]
        complete.header.justify = 'center';
		complete.msg1 = complete.add('statictext', undefined, "Data has been Exported from "+filePass+" images and saved to:");
		complete.msg1.preferredSize = [400, 20]
		complete.msg1.justify = 'center';
		complete.msg2= complete.add('statictext', undefined, textFilePath, {multiline:true});
		complete.msg2.preferredSize = [400, 40];
		complete.msg2.justify = 'center';
         
         complete.msg3 = complete.add('statictext', undefined, "The Custom Field Names option was selected.\nThese field names were exported:", {multiline:true});
         complete.msg3.preferredSize = [0, 0]; //.preferredSize = [400, 40];
         complete.msg3.justify = 'center';     
         complete.msg4 = complete.add('edittext', undefined, customHeadersExported.join("\n"), {multiline:true});
         complete.msg4.justify = 'left';     	
        if(setHeaders.text == "Using Custom Field Names"){
            complete.msg3.minimumSize = [400, 40];
            complete.msg3.maximumSize = [400, 40];
            complete.msg4.minimumSize = [250, 300];
            complete.msg4.maximumSize = [250, 300];
            }
		// begin problems
		complete.problem = complete.add('group');
		complete.problem.orientation = 'column';	
		complete.problem.maximumSize = [0, 0];

		complete.problem.header = complete.problem.add('statictext', undefined, "But...");

		complete.problem.msg = complete.problem.add('statictext', undefined, "There was a problem exporting data from "+fileFailArr.length+" images.");
		complete.problem.btn=  complete.problem.add('button', undefined, "Which files?");
		complete.problem.btn.onClick = showProblems;
		complete.problem.msg2 = complete.problem.add('statictext', undefined, "The metadata structure may be invalid. Try opening and saving the file(s) in Photoshop and exporting again.", {multiline:true});
		complete.problem.msg2.minimumSize = [350, 40];
        complete.problem.msg2.maximumSize = [350, 40];

		function showProblems (){
			var problems = new Window('palette', "Problems");
			complete.problem.files = problems.add('statictext', undefined, fileFailArr.join("\n"), {multiline:true});
			complete.problem.files.minimumSize = [300, 40];
             complete.problem.files.maximumSize = [300, 40];

			complete.okBtn = problems.add('button', undefined, "Continue");
			complete.okBtn.onClick =  function(){ 
				problems.hide();
				}
			problems.show();
			}
		// Continue button
		complete.okBtn = complete.add('button', undefined, "Continue");
		complete.okBtn.onClick =  function(){ 
			complete.hide();
			}
			} // close export brace 1
		complete.show();		
		// Close the file  "^VRA_Data.txt"
		dataExport.close();
		}  // close "function exportToFile(){"
  ////////////////////////////////////////////////
 ////////// END EXPORT //////////
////////////////////////////////////////////////
  //////////////////////////////////////
 ////////// IMPORT //////////
//////////////////////////////////////
function importFromFile(){
        var appDataPlgnSet = File (appDataFwdSlash + plgnPrefs + plgnOpt + plgnSet);
        appDataPlgnSet.open ("w", "TEXT", "ttxt");
            appDataPlgnSet.write (exportWhich.folderRb.value  + "|");
            appDataPlgnSet.write (exportWhich.subfoldersCb.value  + "|");  
            appDataPlgnSet.write (exportWhich.thumbsRb.value + "|");
            appDataPlgnSet.write (exportOptions.datesCb.value + "|");
            appDataPlgnSet.write (dataSource.text + "|");
            appDataPlgnSet.write (writeOptions.appendRb.value+ "|");
            appDataPlgnSet.write(writeOptions.overwriteRb.value + "|");
            appDataPlgnSet.write (IgnoreExtCb.value+ "|");
            appDataPlgnSet.write (fillSubjCb.value+ "|");
            appDataPlgnSet.write (fillCptCb.value+ "|");     
            appDataPlgnSet.write (addLabelCb.value+ "|");
            appDataPlgnSet.write (exportOptionsLfCb.value+"|");
            appDataPlgnSet.write (exportChoice+"|");
            appDataPlgnSet.write (exportWhich.folderEt.text + "|");
            appDataPlgnSet.write (imageLoc.text+ "|");
            appDataPlgnSet.write (imageLocSubfoldersCb.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.Path.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.Name.value+ "|");
            appDataPlgnSet.write (dataSourceOptions.enabled+ "|");
            appDataPlgnSet.write (IgnoreExtCb.enabled+ "|");
            appDataPlgnSet.write (fillTitleCb.value+ "|");
			appDataPlgnSet.write (customHeadersArray+ "|");
			appDataPlgnSet.write (buttonsChoice.defaultHeadersRb.value + "|");
			appDataPlgnSet.write (buttonsChoice.customHeadersRb.value);
            appDataPlgnSet.close();
    
		if (!imageLoc.text){
			app.beep();                  
			Window.alert ("ERROR: \nPlease select a folder of images");
			return false;
			}
	 
		 if (!dataSource.text){
			app.beep();                  
			Window.alert ("ERROR: \nPlease select a text file");
			return false;
			}

		// data source text file
		var textFileLoad = File (dataSource.text.split (" ").join ("%20"));
		// open the data text file
		var textFileLoad = File (textFileLoad);
		textFileLoad.open ('r');
		var textFile = textFileLoad.read().split ('\n');
		textFileLoad.close(); 
		var textFileHeaders = textFile[0].split ("\t");
		var selectedFolder = Folder(imageLoc.text.split (" ").join ("%20"));
		var allFiles = [];
		
/*TEST - show window with list of all file names in the import text file
var textFileNameArr = [];
            for (var L1 = 0; L1 < textFile.length; L1++) {
				 var textFileRead = textFile[L1].split ("\t")
				// if  there is a filename value, push each file name to an array to check for dupes
				if(textFileRead[0]){
				 textFileNameArr.push(textFileRead[0]);  
					}
				}
		textFileNameArr.push("END"); 
		// test info window	
		var testWindow = new Window('palette', "File names in import text file");
		var testMessage = testWindow.add('edittext', undefined, "",{multiline:true});
		testMessage.preferredSize = [300,500];
		testMessage.text = textFileNameArr.join('\n')
		testWindow.show()
*/	
		
		//  TODO: create report on which fields were and were not in the text file
		// open selectedFolder add the path of every file found to the 'allFiles' array. this will be the list of files to be exported
		function getFolder(selectedFolder) {
			var allFilesList = selectedFolder.getFiles();	 
			for (var L1 = 0; L1 < allFilesList.length; L1++) {
				var myFile = allFilesList[L1];
				if (myFile instanceof File && testFileExtension(myFile) == true && testFilePrefix(myFile) == true) {
					allFiles.push(myFile); 
					}
				}
			}

		// open selectedFolder and all subfolders and add the path of every file found to the 'allFiles' array. this will be the list of files to be exported
		function getSubFolders(selectedFolder) {
			 var allFilesList = selectedFolder.getFiles();		 
			 for (var L1 = 0; L1 < allFilesList.length; L1++) {
				  var myFile = allFilesList[L1];
				  if (myFile instanceof Folder){
					   getSubFolders(myFile);
				  }
				  if (myFile instanceof File && testFileExtension(myFile) == true && testFilePrefix(myFile) == true) {
					   allFiles.push(myFile); 
				  }
			 }	
		}			
		// if "Include subfolders" is not checked, only read the files in the selected folder
		if (imageLocSubfoldersCb.value == false){
			locateFilesProgress.show();
			getFolder(selectedFolder);
			locateFilesProgress.hide();
			}
		// if "Include subfolders" is checked, read all the files in the selected folder and its subfolders 
		if (imageLocSubfoldersCb.value == true){
			locateFilesProgress.show();
			getSubFolders(selectedFolder);
			locateFilesProgress.hide();
			}	
 //here!  can this same function on line 2941 be deleted?
   	// get the array index of the specified header string
			if (typeof Array.prototype.indexOf != "function") {  
				Array.prototype.indexOf = function (el) {  
					for(var i = 0; i < this.length; i++) if(el === this[i]) return i;  
					return -1;  
					}  
                }
// here! test that headers match .txt file 			
if (buttonsChoice.customHeadersRb.value == true){
// create header test arrays without the empty values that can exist in the source
var textFileHeadersTest = []
for (var L0aa = 0; L0aa < textFileHeaders.length; L0aa++){   
	if(textFileHeaders[L0aa]){
		textFileHeadersTest.push(textFileHeaders[L0aa])
		}
	}
var customHeadersTest = []
for (var L0ab = 0; L0ab < headerObject.length; L0ab++){   
	if(customHeadersArray[L0ab]){
		customHeadersTest.push(customHeadersArray[L0ab])
		}
	}
// create new array to slice matched values from (so original array remains intact for other comparisons)
var aNotInB = textFileHeadersTest.slice(0);
var bNotInA = customHeadersTest.slice(0);

function compare(arr1,arr2){
	for (var L0 = 0; L0 < arr1.length; L0++){    
		for (var L1 = 0; L1 < arr2.length; L1++){    
			if(arr1[L0] == arr2[L1]){
				arr1.splice(L0, 1)
				}
			}
		}
	}
compare(aNotInB,customHeadersTest)
compare(bNotInA,textFileHeadersTest)

if(aNotInB.length > 0 || bNotInA.length > 0){
	alert("Import file headers not found in settings: \n"+aNotInB.join('\n')+
	"\n\nSettings headers not found in import file: \n"+bNotInA.join('\n'))
//	return false;
	}
}

 for (var L0a = 0; L0a < headerObject.length; L0a++){    
	var filenameHeader = "";
	if(headerObject[L0a].header == "File Name (required)"){	
		if (buttonsChoice.customHeadersRb.value == true){
			if(headerObject[L0a].customHeader.length > 0){
				filenameHeader = headerObject[L0a].customHeader				
				}    			
			}      
		// else use default header and path
		else{
			filenameHeader = headerObject[L0a].header
			}
		// run the import
		if(filenameHeader.length > 0){	// add else with alert 'No matching headers fo			
			var filenameIndex = textFileHeaders.indexOf(filenameHeader) //problem
            }
        }
    }
// if default headers used, alert if File Name (required) not in text file
if(buttonsChoice.defaultHeadersRb.value == true && textFileHeaders[filenameIndex] != headerObject[0].header){
	alert("You are using Default Headers, so your import metadata must have the column: File Name (required)\n\nPlease check your spreadsheet")
	return false
	}

 //here! problem if path column doesn't exist?
 for (var L0b = 0; L0b < headerObject.length; L0b++){    
	var pathHeader = "";
	if(headerObject[L0b].header == 'File Path (optional)'){	
		if (buttonsChoice.customHeadersRb.value == true){
			if(headerObject[L0b].customHeader.length > 0){
				pathHeader = headerObject[L0b].customHeader				
				}                              
			}            
		// else use default header and path
		else{
			pathHeader = headerObject[L0b].header
			}
		// run the import
		if(pathHeader.length > 0){	// add else with alert 'No matching headers fo
			var pathIndex = textFileHeaders.indexOf(pathHeader) //problem
		}
	}
	} 
        //  if "Match on path" is selected check that column B has a value, else show alert
        if (dataSourceOptions.Path.value == true){
            // check for existence of directory in text file column B
        //    textIndex = textFileHeaders.indexOf('File Path (optional)')    
            var textFilePathBlank = 0;
            for (var L1 = 1; L1 < textFile.length; L1++) {			
                var textFileRead = textFile[L1].split ('\t')				
                if(textFileRead[0]&& !textFileRead[pathIndex]){ // todo: use indexOf instead of assuming textFileRead[0] IF custom headers selected
                    textFilePathBlank++;
                    }
                } 
			// textFileRead[0].length > 0 && 

            if (textFilePathBlank > 0){
                app.beep()
                Window.alert("Some items in your text file do not have a file path.\n\n"+
                "Your options are:\n"+
                " •  Check column 'B'  in your spreadsheet and\n"+
                "     add the missing path.\n"+
                " •  Use 'Match on Filename'.");
                return false;
                }
            }
     
        // if "include subfolders" is not selected, check .txt file for duplicate file names and, if any are found, display a list of them. 
        if(imageLocSubfoldersCb.value == false){
            var textFileNameArr = [];
            for (var L1 = 0; L1 < textFile.length; L1++) {
				 var textFileRead = textFile[L1].split ("\t")
				// if  there is a filename value, push each file name to an array to check for dupes
				if(textFileRead[filenameIndex]){ // todo: use indexOf instead of assuming textFileRead[0] IF custom headers selected
				 textFileNameArr.push(textFileRead[filenameIndex]);   // todo: use indexOf instead of assuming textFileRead[0] IF custom headers selected
					}
				}
            txtFileNameDupes=[],
            counts={};
            for (var L1=0; L1 < textFileNameArr.length; L1++) {
                var item = textFileNameArr[L1];
                var count = counts[item];
                counts[item] = counts[item] >= 1 ? counts[item] + 1 : 1;
                }
            for (var item in counts) {
                if(counts[item] > 1)
                  txtFileNameDupes.push(item);
                }          
            if(txtFileNameDupes.length > 0){    
                app.beep();
                var duplicatesFound = new Window('palette', "Duplicates"); 
                duplicatesFound.alignChildren = 'left';
                var duplicatesFoundHeaderValue = "Duplicate filenames have been found, preventing the import from running."
                textDuplicatesHeader = duplicatesFound.add('statictext', [0, 0, 500, 20], duplicatesFoundHeaderValue);
           // list of duplicates in text file
                textDuplicates = duplicatesFound.add('panel', undefined, "Duplicates in selected text file");
                textDuplicates.alignChildren = 'left';
                textDuplicates.spacing = 3;
                textFilePath = textDuplicates.add('statictext', [0,0,800,20], dataSource.text);
                textDuplicatesBtn = textDuplicates.add('button', undefined, "Save list of duplicates to desktop");
                textDuplicatesBtn.onClick = function(){
                    // Create a text file on the desktop with only the headers.  This can be used as a template in Excel to create properly formatted text for the import function
                    var dupesInText = "dupes_in_text_"+dateYMD+".txt"
                    // Create and open the file so it can recieve data
                    var duplicateImages = new File (desktop+dupesInText)                
                    duplicateImages.encoding = "UTF8";
                    duplicateImages.open ("w", "TEXT", "ttxt");   
                    // write .txt file path
                    duplicateImages.write ("DUPLICATES FOUND IN: "+dataSource.text+"\n\n");
                    // write paths and filenames to the .txt file
                    duplicateImages.write (txtFileNameDupes.join("\n"));
                    // Close the file
                    duplicateImages.close();
                    Window.alert ("A new file named:\n\n"+dupesInText+"\n\nhas been created on your desktop.", "Success!")						
                    };
                var duplicatesOptionsValue = 
                "Your options are:\n"+
                "  •  Remove or change the duplicate filenames\n"+
                "  •  If your text file contains paths in column' A', select 'Match on path and filename'\n"+
                "  •  De-select the subfolders option\n"+
                "  •  Select a subfolder that has no duplicates\n"+
                "  •  Move duplicates so they are not in subfolders of the selected parent folder\n"+
                "  •  Rename duplicates";
                duplicatesOptions = duplicatesFound.add('statictext', [0, 0, 800, 120], duplicatesOptionsValue, {multiline:true});        
            // Close button
            duplicatesFound.cancelBtn = duplicatesFound.add('button', undefined, "Close");
            duplicatesFound.cancelBtn.alignment = 'center';
            duplicatesFound.cancelBtn.onClick =  function(){ 
                duplicatesFound.hide();
                }
                duplicatesFound.show();
                return false; 
                }
            }
 
		// if "include subfolders" "Match on filename" are selected, check .txt file for duplicate file names and, if any are found, display a list of them. 
		if(imageLocSubfoldersCb.value == true && dataSourceOptions.Name.value == true){
			//  check filenames in text file column B for duplicate filenames
			var textFileNameArr = [];
            var textFilePathArr = [];
            var textFilePathBlank = 0;
			 for (var L1 = 0; L1 < textFile.length; L1++) {
				 var textFileRead = textFile[L1].split ("\t")
				// if  there is a filename value, push each file name to an array to check for dupes
				if(textFileRead[filenameIndex]){  // todo: use indexOf instead of assuming textFileRead[0] IF custom headers selected
					 textFileNameArr.push(textFileRead[filenameIndex]);  // todo: use indexOf instead of assuming textFileRead[0] IF custom headers selected
					 }
				}  
		
		// run find duplicates against text file filenames array
		var length = textFileNameArr.length,
		txtFileNameDupes=[],
		counts={};
		for (var L1=0; L1 < length; L1++) {
			var item = textFileNameArr[L1];
			var count = counts[item];
			counts[item] = counts[item] >= 1 ? counts[item] + 1 : 1;
			}

		for (var item in counts) {
			if(counts[item] > 1)
			  txtFileNameDupes.push(item);
			}
			
		// check filenames in selected directory include subfolders for duplicate filenames
		// get just the file name from allFiles so we can compare it to the file name in the text file
		var fileNameArr = [];
		for (var L2 = 0; L2 < allFiles.length; L2++) {
		  if (Folder.fs == 'Windows'){
			var splicePathIndex = allFiles[L2].toString().lastIndexOf ("/")
			}
		else{
			var splicePathIndex = allFiles[L2].toString().lastIndexOf ("\\")
            var splicePathIndex = allFiles[L2].toString().lastIndexOf ("/")
			}
		var filenameOnly = allFiles[L2].toString().slice(splicePathIndex+1).split("%20").join(" ");
		fileNameArr.push(filenameOnly)
		}

		// run find duplicates against filenames array			 
		var len=fileNameArr.length,
		out=[],
		counts={};
		for (var L1=0;L1<len;L1++) {
			var item = fileNameArr[L1];
			var count = counts[item];
			counts[item] = counts[item] >= 1 ? counts[item] + 1 : 1;
			}
		for (var item in counts) {
			if(counts[item] > 1)
			  out.push(item);
			}
        if(out.length > 0 || txtFileNameDupes.length > 0){    
			var duplicatesWithPath = [];
			 for (var L1 = 0; L1 < out.length; L1++){ 
				for (var L2 = 0; L2 < allFiles.length; L2++){   
				  if(allFiles[L2].toString().match(RegExp (out[L1])) != null){
				     duplicatesWithPath.push(allFiles[L2]);	  
					}
				   }	  
				}   
            app.beep();
            var duplicatesFound = new Window('palette', "Duplicates"); 
            duplicatesFound.alignChildren = 'left';
            var duplicatesFoundHeaderValue = "Duplicate filenames have been found, preventing the import from running."
                      
// test info window	
		//var testMessage = duplicatesFound.add('edittext', [0,0,300,500], "",{multiline:true});
            // list of duplicates in text file
            if(txtFileNameDupes.length > 0){ 	
                textDuplicates = duplicatesFound.add('panel', undefined, "Duplicates in selected text file");
                textDuplicates.alignChildren = 'left';
                textDuplicates.spacing = 3;
                textFilePath = textDuplicates.add('statictext', [0,0,800,20], dataSource.text);
             //   textDuplicatesList = textDuplicates.add ('ListBox', [0, 0, 800, 150], txtFileNameDupes);
           //     textDuplicatesList = textDuplicates.add ('edittext', [0, 0, 800, 150], txtFileNameDupes.join("\n"), {multiline:true});
                textDuplicatesBtn = textDuplicates.add('button', undefined, "Save list of duplicates to desktop");
            textDuplicatesBtn.onClick = function(){
            // Create a text file on the desktop with only the headers.  This can be used as a template in Excel to create properly formatted text for the import function
            var dupesInText = "dupes_in_text_"+dateYMD+".txt"
            // Create and open the file so it can recieve data
            var duplicateImages = new File (desktop+dupesInText)                
            duplicateImages.encoding = "UTF8";
            duplicateImages.open ('w', 'XLS', 'XCEL');   
            // write .txt file path
            duplicateImages.write ("DUPLICATES FOUND IN: "+dataSource.text+"\n\n");
            // write paths ans filenames to the .txt file
            duplicateImages.write (txtFileNameDupes.join("\n"));
            // Close the file
            duplicateImages.close();
            Window.alert ("A new file named:\n\n"+dupesInText+"\n\nhas been created on your desktop.", "Success!")						
            };
			var textDuplicatesOptionsValue = 
			"Your options are:\n"+
			"  •  Remove the duplicate filenames from your text file\n"+
			"  •  If your text file contains paths in column' A', select 'Match on path and filename'\n"+
			"  •  De-select the subfolders option\n"+
			"  •  Select a subfolder that has no duplicates\n"+
			"  •  Move duplicates so they are not in subfolders of the selected parent folder\n"+
			"  •  Rename duplicates";
			textDuplicatesOptions = textDuplicates.add('statictext', [0, 0, 800, 120], textDuplicatesOptionsValue, {multiline:true});         
		}
            // list of duplicates in folder include subfolders
            if(out.length > 0){	
                folderDuplicates = duplicatesFound.add('panel', undefined, "Duplicates in selected folder of image files");
                folderDuplicates.spacing = 3;
                folderDuplicates.alignChildren = 'left';
                folderPath = folderDuplicates.add('statictext', [0,0,800,20], imageLoc.text+" ... and subfolders");
            //    folderDuplicatesList = folderDuplicates.add ('ListBox', [0, 0, 800, 150], duplicatesWithPath);
                folderDuplicatesBtn = folderDuplicates.add('button', undefined, "Save list of duplicates to desktop");
                folderDuplicatesBtn.onClick = function(){
                // Create a text file on the desktop with only the headers.  This can be used as a template in Excel to create properly formatted text for the import function    
                var dupesInFolder = "dupes_in_folders_"+dateYMD+".txt"
                // Create and open the file so it can recieve data
                var duplicateImages = new File (desktop+dupesInFolder)                
                duplicateImages.encoding = "UTF8";
                duplicateImages.open ("w", "TEXT", "ttxt");
                
                // write paths ans filenames to the .txt file
                duplicateImages.write (duplicatesWithPath.join("\n"));
                // Close the file
                duplicateImages.close();
                Window.alert ("A new file named:\n\n"+dupesInFolder+"\n\nhas been created on your desktop.", "Success!")						
                };
            var duplicatesOptionsValue = 
                "Your options are:\n"+
                "  •  Remove or change the duplicate filenames\n"+
                "  •  If your text file contains paths in column' A', select 'Match on path and filename'\n"+
                "  •  De-select the subfolders option\n"+
                "  •  Select a subfolder that has no duplicates\n"+
                "  •  Move duplicates so they are not in subfolders of the selected parent folder\n"+
                "  •  Rename duplicates";
                duplicatesOptions = duplicatesFound.add('statictext', [0, 0, 800, 120], duplicatesOptionsValue, {multiline:true});
                }
            // Close button
            duplicatesFound.cancelBtn = duplicatesFound.add('button', undefined, "Close");
            duplicatesFound.cancelBtn.alignment = 'center';
            duplicatesFound.cancelBtn.onClick =  function(){ 
                duplicatesFound.hide();
                }
             duplicatesFound.show();
             return false; 
             } // close if(out.length > 0 || txtFileNameDupes.length > 0)       
        } // close if(imageLocSubfoldersCb.value == true)
		 
	// Close the main UI window before running the import
	mainWindow.hide()
     // begin reading data from file
     { 	
	// Variables used for collecting pass/fail data for report
	var filePass = 0;
	var fileFail = 0;
	var fileFailArr = [];
	var couldNotOpen = [];
    var couldNotClose = [];
	var propFail = 0;
    var propFailName = [];
	var noMatch = [];
	var propPass = [];
    var customHeadersImported = []; 

for (var L0 = 0; L0 < headerObject.length; L0++){ 
	if(headerObject[L0].customHeader.length > 0){
		customHeadersImported.push(headerObject[L0].customHeader)
		}
	}
		// Progress bar window to show files are importing
		var importingProgress =  new Window ('palette', "Importing Metadata");
        importingProgress.alignChildren = 'center';
		importingProgress.preferredSize = [400,80];
		importingProgress.count = importingProgress.add('statictext', undefined, allFiles.length+" image files to proccess");
		importingProgress.progBar = importingProgress.add('progressbar', [0,20,390,40]);
	
    {
        for (var L3 = 0; L3 < allFiles.length; L3++){
			if ( allFiles.length > 50){
				importingProgress.progBar.value = Math.round ((L3 / allFiles.length) * 100);  
				  importingProgress.center();
				  importingProgress.show();
			 }

      //   if (allFiles[L3].hasMetadata)       
		 if (allFiles[L3]){         
		// Get the selected file
        var imageFile = allFiles[L3];

        try{
 // try to open file. if it fails, save file path in error log
try{
    // if file is an .xmp sidecar - read the xmp directly to an XMPMeta Object
    if(imageFile.name.match(/\.xmp/i) != null){
        var xmpFile = Folder (File(imageFile.fsName)); 
        xmpFile.open('r');  
        var xmpData = new XMPMeta(xmpFile.read());  
          xmpFile.close();  
        }
    else{
        // if file is not an .xmp sidecar pull XMP from file
        var xmpFile = new XMPFile(imageFile.fsName, XMPConst.UNKNOWN, XMPConst.OPEN_FOR_UPDATE);
        // convert to xmp
        var xmpData = xmpFile.getXMP();
        }
    }
catch(couldNotOpenError){}        
				// delete label before import begins  Data imported
				var prop = xmpData.getProperty (XMPConst.NS_XMP, "Label");		
				var patt1=new RegExp("VRA metadata imported"); 	
				if (patt1.test(prop) == true){				
					xmpData.deleteProperty (XMPConst.NS_XMP, 'Label');	
					}
				// get just the file name from allFiles so we can compare it to the file name in the text file
				 if (Folder.fs == 'Windows'){
					var splicePathIndex = allFiles[L3].toString().lastIndexOf ("/")
					}
				else{
					var splicePathIndex = allFiles[L3].toString().lastIndexOf ("\\")
                       var splicePathIndex = allFiles[L3].toString().lastIndexOf ("/")
					}
				// get just the file directory
				var spliceDirectory = allFiles[L3].toString().slice(splicePathIndex+1).split("%20").join(" ");
				// get just the file name
				var spliceName = allFiles[L3].toString().slice(splicePathIndex+1).split("%20").join(" ");   
                    // read the tab delimited file
                for (var L4 = 1; L4 < textFile.length; L4++){       // here! when col A not filename;  is  L4 = 1; causing first column to not write?               
                    var textFileValue = textFile[L4].split ('\t');
                    if (IgnoreExtCb.value == true){		
                        var thumbName = spliceName.split ('.');						
                        thumbName.pop();
                        var thumbName = thumbName.join ('.');
                        var impFileName = textFileValue[filenameIndex].split ('.'); // todo: use indexOf instead of assuming textFileRead[0] IF custom headers selected
                        impFileName.pop();
                        var impFileName = impFileName.join ('.');	
                        }         					 
                // if image file name matches the filename in the the first position of the text file array
                else{
                    var thumbName= spliceName;
                    var impFileName = textFileValue[filenameIndex]; // todo: use indexOf instead of assuming textFileRead[0] IF custom headers selected
                    }       
             
    if(dataSourceOptions.Path.value == true){  
        var thumbName = allFiles[L3];
        var impFileName = textFileValue[pathIndex].split(" ").join("%20")+textFileValue[filenameIndex].split(" ").join("%20"); // todo: use indexOf instead of assuming textFileRead[0] IF custom headers selected
        }         
// TODO: is .toLowerCase() neccessary for a match?
                 if (thumbName == impFileName){						 
// TODO: import is matched on column header value.  BUT, if a column is not in the spreadsheet, it will not be changed, including bad data that you want to be changed.  Should I give the user a warning or an option to clear all VRA & IPTC fields for fresh import of only what is in their spreadsheet?	
	        	// get the array index of the specified header string
                // here! can this be deleted?
			if (typeof Array.prototype.indexOf != "function") {  
				Array.prototype.indexOf = function (el) {  
					for(var i = 0; i < this.length; i++) if(el === this[i]) return i;  
					return -1;  
					}  
                }
			
                // import text	
                for (var L5 = 0; L5 < headerObject.length; L5++){    
                    var textHeader = "";
                    if(headerObject[L5].type == 'text'){
                        try{		
                            // if customHeader length > 0, use it and path  
                            if (buttonsChoice.customHeadersRb.value == true){
                                if(headerObject[L5].customHeader.length > 0){
                                    textHeader = headerObject[L5].customHeader
                          //        $.writeln(headerObject[L5].customHeader) 
                                    }                              
                                }            
                            // else use default header and path
                            else{
                                textHeader = headerObject[L5].header
                                }		
                            // run the import
                            if(textHeader.length > 0){
                                var prop = xmpData.getProperty(headerObject[L5].namespace, headerObject[L5].path);  							
                                var index = textFileHeaders.indexOf(textHeader)	
                         //      if(index > 0){
						//	customHeadersImported.push(headerObject[L5].customHeader)	         
                                if (writeOptions.overwriteRb.value == true){		      
                                    xmpData.deleteProperty(headerObject[L5].namespace, headerObject[L5].path);                   
                                    if (textFileValue[index].length > 0){
						
                                        xmpData.setProperty (headerObject[L5].namespace, headerObject[L5].path, textFileValue[index].split("(LF)").join("\n").split("(CR)").join("\r").split("(HT)").join("\t").split("\"").join(""));
                                        }
                                    }
                                else if (prop == undefined && textFileValue[index].length > 0){
                                    xmpData.setProperty (headerObject[L5].namespace, headerObject[L5].path, textFileValue[index].split("(LF)").join("\n").split("(CR)").join("\r").split("(HT)").join("\t").split("\"").join(""));
                                    } 
								propPass.push(textHeader)
                         //   } // close  if(index > 0)
                        }   // close if(textHeader.length > 0)      
                                } // close try
                                catch(propFail){propFail++, propFailName.push(path)}
                        }	// close if(headerObject[L5].type == 'text')
                    } // close import text

                    // import date	
                    for (var L6 = 0; L6 < headerObject.length; L6++){    
                        var dateHeader = "";
                        if(headerObject[L6].type == 'date'){
                            try{ 
                                // if customHeader length > 0, use it and path  
                                if (buttonsChoice.customHeadersRb.value == true){
                                    if(headerObject[L6].customHeader.length > 0){
                                        dateHeader = headerObject[L6].customHeader
                                       
                                        }                                      
                                    }            
                                // else use default header and path
                                else{
                                    dateHeader = headerObject[L6].header
                                    }		
                                // run the import
                                if(dateHeader.length > 0){	// add else with alert 'No matching headers found		
                                    var index = textFileHeaders.indexOf(dateHeader)	             
                                       if(index > 0){
									//	 customHeadersImported.push(headerObject[L6].customHeader)    
                                        if (writeOptions.overwriteRb.value == true){
                                            xmpData.deleteProperty(headerObject[L6].namespace, headerObject[L6].path);
                                            if (textFileValue[index].length > 0){
                                                xmpData.setProperty (headerObject[L6].namespace, headerObject[L6].path, textFileValue[index].split ('_').join (""));
                                                }
                                            }
                                        else if (prop == undefined && textFileValue[index].length > 0){
                                            xmpData.setProperty (headerObject[L6].namespace, headerObject[L6].path, textFileValue[index].split ('_').join (""));
                                            }
										propPass.push(dateHeader)   
                                    } // close if(dateHeader.length > 0)
                                }                                             
                                } // close try
                                    catch(propFail){propFail++, propFailName.push(path)}
                            }	// close if(headerObject[L6].type == 'date')
                        } // close import date
                                        
					// import langAlt arrays	
					for (var L7 = 0; L7 < headerObject.length; L7++){    
						var langAltHeader = "";
						if(headerObject[L7].type == 'langAlt'){
							try{ 
								// if customHeader length > 0, use it and path  
								if (buttonsChoice.customHeadersRb.value == true){
									if(headerObject[L7].customHeader.length > 0){
										langAltHeader = headerObject[L7].customHeader
										}
									}            
								// else use default header and path
								else{
									langAltHeader = headerObject[L7].header
									}		
								// run the import
								if(langAltHeader.length > 0){	// add else with alert 'No matching headers found		
									var index = textFileHeaders.indexOf(langAltHeader)	
									var count = xmpData.countArrayItems(headerObject[L7].namespace, headerObject[L7].path);
												var prop = textFileValue[index].split('\"').join("");		
												if(index > 0){
												if (writeOptions.overwriteRb.value == true){
													 xmpData.deleteProperty(headerObject[L7].namespace, headerObject[L7].path);  
													 if (textFileValue[index].length > 0){
													 xmpData.appendArrayItem (headerObject[L7].namespace, headerObject[L7].path, prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
													xmpData.setQualifier    (headerObject[L7].namespace, headerObject[L7].path + '[1]', namespace_W3, "lang", "x-default");
													}
												}
												else
													 if (count == 0 && textFileValue[index].length > 0){
														  xmpData.appendArrayItem (headerObject[L7].namespace, headerObject[L7].path, prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
														  xmpData.setQualifier (headerObject[L7].namespace, headerObject[L7].path + '[1]', namespace_W3, "lang", "x-default");
													 }
									if (writeOptions.overwriteRb.value == true){
											}
										propPass.push(langAltHeader)
									} // close if(langAltHeader.length > 0)
								}						
								} // close try
									catch(propFail){propFail++, propFailName.push(path)}
							}	// close if(headerObject[L7].type == 'langAlt')
						} // close import langAlt arrays

						// import bag arrays	
for (var L8 = 0; L8 < headerObject.length; L8++){    
	var bagHeader = "";
	if(headerObject[L8].type == 'bag'){
		try{ 
			// if customHeader length > 0, use it and path  
			if (buttonsChoice.customHeadersRb.value == true){
				if(headerObject[L8].customHeader.length > 0){
					bagHeader = headerObject[L8].customHeader
					}
				}            
			// else use default header and path
			else{
				bagHeader = headerObject[L8].header
				}	
			// run the import
			if(bagHeader.length > 0){	// add else with alert 'No matching headers found		
				var index = textFileHeaders.indexOf(bagHeader)
				 if(index > 0){
				if (writeOptions.overwriteRb.value == true){
						var count = xmpData.countArrayItems (headerObject[L8].namespace, headerObject[L8].path); 
						if (writeOptions.overwriteRb.value == true){
							xmpData.deleteProperty(headerObject[L8].namespace, headerObject[L8].path);   
							if (textFileValue[index].length > 0){
								xmpData.setProperty (headerObject[L8].namespace, headerObject[L8].path, "", XMPConst.ARRAY_IS_UNORDERED);
								var prop = textFileValue[index].split ('"').join ("").split('; ').join(';').split (';');
								for (var L1 = 1; L1 < (prop.length + 1); L1++)
								xmpData.setProperty (headerObject[L8].namespace, headerObject[L8].path + '[' + L1 + ']', prop[L1 - 1]);
								}
							}
						else
						if (count == 0 && textFileValue[index].length > 0){
								xmpData.setProperty (headerObject[L8].namespace, headerObject[L8].path, "", XMPConst.ARRAY_IS_UNORDERED);
								var prop = textFileValue[index].split ('"').join ("").split('; ').join(';').split (';');
								for (var L1 = 1; L1 < (prop.length + 1); L1++)
								xmpData.setProperty (headerObject[L8].namespace, headerObject[L8].path + '[' + L1 + ']', prop[L1 - 1]);
								}
							} 
					propPass.push(bagHeader)	
				} // close if(bagHeader.length > 0)
			}
		
			} // close try
				catch(propFail){propFail++, propFailName.push(path)}
		}	// close if(headerObject[L8].type == 'bag')
	} // close import bag arrays

// import seq arrays	
for (var L9 = 0; L9 < headerObject.length; L9++){    
	var seqHeader = "";
	if(headerObject[L9].type == 'seq'){
		try{ 
			// if customHeader length > 0, use it and path  
			if (buttonsChoice.customHeadersRb.value == true){
				if(headerObject[L9].customHeader.length > 0){
					seqHeader = headerObject[L9].customHeader
					}
				}            
			// else use default header and path
			else{
				seqHeader = headerObject[L9].header
				}		
			// run the import
			if(seqHeader.length > 0){	// add else with alert 'No matching headers found		
				var index = textFileHeaders.indexOf(seqHeader)
				 if(index > 0){
				if (writeOptions.overwriteRb.value == true){
					if (writeOptions.overwriteRb.value == true){
									xmpData.deleteProperty(headerObject[L9].namespace, headerObject[L9].path);       
									if (textFileValue[index].length > 0){
										xmpData.setProperty (headerObject[L9].namespace, headerObject[L9].path, "", XMPConst.ARRAY_IS_ORDERED);
										var prop = textFileValue[index].split ('"').join ("").split('; ').join(';').split (';');
										for (var L1 = 1; L1 < (prop.length + 1); L1++)
										xmpData.setProperty (headerObject[L9].namespace, headerObject[L9].path + '[' + L1 + ']', prop[L1 - 1]);
										}
									}
								else
								if (count == 0 && textFileValue[index].length > 0){
									xmpData.setProperty (headerObject[L9].namespace, headerObject[L9].path, "", XMPConst.ARRAY_IS_ORDERED);
									var prop = textFileValue[index].split ('"').join ("").split('; ').join(';').split (';');
									for (var L1 = 1; L1 < (prop.length + 1); L1++)
									xmpData.setProperty (headerObject[L9].namespace, headerObject[L9].path + '[' + L1 + ']', prop[L1 - 1]);
									}
					}
				propPass.push(seqHeader)
				} // close if(seqHeader.length > 0)
			}		
			} // close try
				catch(propFail){propFail++, propFailName.push(path)}
		}	// close if(headerObject[L9].type == 'seq')
	} // close import seq arrays

// import Summary DC Title
var concatDcThdrs = ["Work Title","Image View Description"]
var concatDcTindx = []
for (var L10 = 0; L10 < headerObject.length; L10++){    
	var dcTitleHeader = "";
	if(headerObject[L10].type == 'langAltDcTitle'){
        try{
		// if customHeader length > 0, use it and path  
		if (buttonsChoice.customHeadersRb.value == true){
			if(headerObject[L10].customHeader.length > 0){
                  dcTitleHeader = headerObject[L10].customHeader				
				}
 for (var L10a = 0; L10a < concatDcThdrs.length; L10a++){    
       for (var L10b = 0; L10b < headerObject.length; L10b++){         
        if(headerObject[L10b].header == concatDcThdrs[L10a]){  
            if(headerObject[L10b].customHeader.length > 0){
                concatDcTindx.push(textFileHeaders.indexOf(headerObject[L10b].customHeader))
               //  concatDcTindx[L10a] = textFileHeaders.indexOf(headerObject[L10b].customHeader)
                 //      concat1 = textFileHeaders.indexOf(headerObject[L10b].customHeader)
                    }       
                    else{
                    concatDcTindx[L10a] = L10b
                    }
                }
            }
        var concat1 = concatDcTindx[0]
        var concat2 = concatDcTindx[1]
     }
  /*
    for (var L10a = 0; L10a < headerObject.length; L10a++){    
        if(headerObject[L10a].header == "Work Title"){
            if(headerObject[L10a].customHeader.length > 0){
                    var concat1 = textFileHeaders.indexOf(headerObject[L10a].customHeader)
                    }       
                    else{
                    var concat1 = L10a
                    }
                }
            }
    for (var L10b = 0; L10b < headerObject.length; L10b++){    
        if(headerObject[L10b].header == "Image View Description"){
            if(headerObject[L10b].customHeader.length > 0){
                    var concat2 = textFileHeaders.indexOf(headerObject[L10b].customHeader)
                    }       
                    else{
                    var concat2 = L10b
                    }
                }
            }
          
			// if equiv of vra title exists, use it for concat
			for (var L10a = 0; L10a < headerObject.length; L10a++){  
				if(headerObject[L10a].header =="Work Title"){
					var concat1 = textFileHeaders.indexOf(headerObject[L10a].customHeader)
					}
				}
				// if equiv of vra creator exists, use it for concat
			for (var L10b = 0; L10b < headerObject.length; L10b++){  
				if(headerObject[L10b].header =="Image View Description"){
					var concat2 = textFileHeaders.indexOf(headerObject[L10b].customHeader)
					}
				}
            */
			}  
		// else use default header and path
		else{
                dcTitleHeader = headerObject[L10].header
                var concat1 = textFileHeaders.indexOf(headerObject[3].header)
                var concat2 = textFileHeaders.indexOf(headerObject[43].header)
			}
		// run the import
		 if(dcTitleHeader.length > 0 || (buttonsChoice.customHeadersRb.value == true && fillTitleCb.value == true)){
			 var index = textFileHeaders.indexOf(dcTitleHeader)
            var count = xmpData.countArrayItems(XMPConst.NS_DC, "title");
		  var prop = textFileValue[index].split('(LF)').join('\n') .split ('(CR)').join ('\r').split('(HT)').join('\t').split('\"').join("");			  
		  var createDescArray1 = [textFileValue[concat1], textFileValue[concat2]] ;
		  var createDescArray = []
		  for(var L1 = 0; L1<createDescArray1.length; L1++){
									if(createDescArray1[L1]){
										createDescArray.push(createDescArray1[L1])
									}	
								}
			/*	var createDescArray = [textFileValue[concat1], textFileValue[concat2]] ;	
								for(var L1 = 0; L1<createDescArray.length; L1++){
									if(createDescArray[L1] == ""){
										createDescArray.splice(L1, 1); L1--;
									}	
								}*/
								_title = createDescArray.join(': ');
				 if(index > 0){												
				if (writeOptions.overwriteRb.value == true){
						 xmpData.deleteProperty(XMPConst.NS_DC, "title");               
						 if (textFileValue[index].length > 0 || _title.length > 0){
						if (fillTitleCb.value == true){											
							xmpData.appendArrayItem (XMPConst.NS_DC, "title", _title, 0, XMPConst.ALIAS_TO_ALT_TEXT);
							xmpData.setQualifier (XMPConst.NS_DC, "title" + '[1]', namespace_W3, "lang", "x-default");	
							}
						else{												 
							xmpData.appendArrayItem (XMPConst.NS_DC, "title", prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
							xmpData.setQualifier    (XMPConst.NS_DC, "title" + '[1]', namespace_W3, "lang", "x-default");
							}
					//	customHeadersImported.push("DC Title")
					}
				}
					else
						 if (count == 0 && textFileValue[index].length > 0 || count == 0 && _title.length > 0){
							  if (fillTitleCb.value == true){											
								xmpData.appendArrayItem (XMPConst.NS_DC, "title", _title, 0, XMPConst.ALIAS_TO_ALT_TEXT);
								xmpData.setQualifier (XMPConst.NS_DC, "title" + '[1]', namespace_W3, "lang", "x-default");	
							}
						else{												 
							 xmpData.appendArrayItem (XMPConst.NS_DC, "title", prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
							 xmpData.setQualifier    (XMPConst.NS_DC, "title" + '[1]', namespace_W3, "lang", "x-default");
							}
						 }		
					propPass.push(dcTitleHeader)
                }  // close  if(dcTitleHeader.length > 0){
			}
		        	} // close try
		catch(propFail){propFail++, propFailName.push(path)}
		} // close if(headerObject[L10].type == 'langAltDcDescription'){
	} // close import DC Title
						
// import Summary Description/Caption	
var concatDcDhdrs = ["Work Creator", "Work Title", "Image View Description", "Work Date", "Work Work Type", "Work Materials", "Work Measurements", "Work Repository", "Work Site", "Work Creation Location", "Work Discovery Location", "Work Exhibition Location", "Work Installation Location", "Work Performance Location", "Work ID", "Work Rights"]
var concatDcDindx = []
for (var L11 = 0; L11 < headerObject.length; L11++){    
	var dcDescrHeader = "";
	if(headerObject[L11].type == 'langAltDcDescription'){
        try{
		// if customHeader length > 0, use it and path  
		if (buttonsChoice.customHeadersRb.value == true){
			if(headerObject[L11].customHeader.length > 0){
                    dcDescrHeader = headerObject[L11].customHeader
				}
	 for (var L10a = 0; L10a < concatDcDhdrs.length; L10a++){    
       for (var L10b = 0; L10b < headerObject.length; L10b++){         
        if(headerObject[L10b].header == concatDcDhdrs[L10a]){  
            if(headerObject[L10b].customHeader.length > 0){
                concatDcDindx.push(textFileHeaders.indexOf(headerObject[L10b].customHeader))
                    }       
                    else{
                    concatDcDindx[L10a] = L10b
                    }
                }
            }
			var concat1 = concatDcDindx[0]
			var concat2 = concatDcDindx[1]
			var concat3 = concatDcDindx[2]
			var concat4 = concatDcDindx[3]
			var concat5 = concatDcDindx[4]
			var concat6 = concatDcDindx[5]
			var concat7 = concatDcDindx[6]
			var concat8 = concatDcDindx[7]
			var concat9 = concatDcDindx[8]
			var concat10 = concatDcDindx[9]
			var concat11 = concatDcDindx[10]
			var concat12 = concatDcDindx[11]
			var concat13 = concatDcDindx[12]
			var concat14 = concatDcDindx[13]
			var concat15 = concatDcDindx[14]
			var concat16 = concatDcDindx[15]
			var concat17 = concatDcDindx[16]	
     }
			}            
		// else use default header and path
		// fields: Work Creator; Work Title; Image View Description; Work Date; Work Work Type; Work Materials; Work Measurements; Work Repository; Work Site; Work Creation Location; Work Discovery Location; Work Exhibition Location; Work Installation Location; Work Performance Location; Work ID; Work Rights
		else{			
                dcDescrHeader = headerObject[L11].header	
                var concat1 = textFileHeaders.indexOf(headerObject[2].header)
                var concat2 = textFileHeaders.indexOf(headerObject[3].header)
                var concat3 = textFileHeaders.indexOf(headerObject[43].header)
                var concat4 = textFileHeaders.indexOf(headerObject[4].header)
                var concat5 = textFileHeaders.indexOf(headerObject[7].header)
                var concat6 = textFileHeaders.indexOf(headerObject[8].header)
                var concat7 = textFileHeaders.indexOf(headerObject[10].header)
                var concat8 = textFileHeaders.indexOf(headerObject[11].header)
                var concat9 = textFileHeaders.indexOf(headerObject[12].header)
                var concat10 = textFileHeaders.indexOf(headerObject[24].header)
                var concat11 = textFileHeaders.indexOf(headerObject[25].header)
                var concat12 = textFileHeaders.indexOf(headerObject[26].header)
                var concat13 = textFileHeaders.indexOf(headerObject[27].header)
                var concat14 = textFileHeaders.indexOf(headerObject[28].header)
                var concat15 = textFileHeaders.indexOf(headerObject[29].header)
                var concat16 = textFileHeaders.indexOf(headerObject[31].header)
                var concat17 = textFileHeaders.indexOf(headerObject[32].header)
			}
		// run the import		
		 if(dcDescrHeader.length > 0){
			 var index = textFileHeaders.indexOf(dcDescrHeader)
			 var count = xmpData.countArrayItems(XMPConst.NS_DC, "description");
          var prop = textFileValue[index].split('(LF)').join('\n') .split ('(CR)').join ('\r').split('(HT)').join('\t').split('\"').join("");
            var createDescArray  = [textFileValue[concat1], textFileValue[concat2], textFileValue[concat3], textFileValue[concat4], textFileValue[concat5], textFileValue[concat6], textFileValue[concat7], textFileValue[concat8], textFileValue[concat9], textFileValue[concat10], textFileValue[concat11], textFileValue[concat12], textFileValue[concat13], textFileValue[concat14], textFileValue[concat15], textFileValue[concat16], textFileValue[concat17]];	
            for(var L1 = 0; L1<createDescArray.length; L1++){
                if(!createDescArray[L1]){
                    createDescArray.splice(L1, 1); L1--;
                }	
            }   
            _desc = createDescArray.join('; ').split('(LF)').join('\n') .split ('(CR)').join ('\r').split('(HT)').join('\t').split('\"').join("");	
			 if(index > 0){	
            if (writeOptions.overwriteRb.value == true){
                     xmpData.deleteProperty(XMPConst.NS_DC, "description");               
                     if (textFileValue[index].length > 0 || _desc.length > 0){
                    if (fillCptCb.value == true){											
                        xmpData.appendArrayItem (XMPConst.NS_DC, "description", _desc, 0, XMPConst.ALIAS_TO_ALT_TEXT);
                        xmpData.setQualifier (XMPConst.NS_DC, "description" + '[1]', namespace_W3, "lang", "x-default");	
                        }
                    else{												 
                        xmpData.appendArrayItem (XMPConst.NS_DC, "description", prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
                        xmpData.setQualifier    (XMPConst.NS_DC, "description" + '[1]', namespace_W3, "lang", "x-default");
                        }
                }
            }
                else
                     if (count == 0 && textFileValue[index].length > 0 || count == 0 && _desc.length > 0){
                          if (fillCptCb.value == true){											
                            xmpData.appendArrayItem (XMPConst.NS_DC, "description", _desc, 0, XMPConst.ALIAS_TO_ALT_TEXT);
                            xmpData.setQualifier (XMPConst.NS_DC, "description" + '[1]', namespace_W3, "lang", "x-default");	
                        }
                    else{												 
                         xmpData.appendArrayItem (XMPConst.NS_DC, "description", prop, 0, XMPConst.ALIAS_TO_ALT_TEXT);
                         xmpData.setQualifier    (XMPConst.NS_DC, "description" + '[1]', namespace_W3, "lang", "x-default");
                        }
                     }
				 propPass.push(dcDescrHeader)
                }  // close  if(dcDescrHeader.length > 0){
			}		
        	} // close try
		catch(propFail){propFail++, propFailName.push(path)}
		} // close if(headerObject[L11].type == 'langAltDcDescription'){
	} // close import Summary Description/Caption						
						
	// import Summary Keywords	
	var concatDcShdrs = ["Work Style/Period","Work Culture","Work Work Type","Work Techniques"]
	var concatDcSindx = []
    for (var L12 = 0; L12 < headerObject.length; L12++){    
        var dcSubjectHeader = "";
        if(headerObject[L12].type == 'bagDcSubject'){
            try{
            // if customHeader length > 0, use it and path  
            if (buttonsChoice.customHeadersRb.value == true){
                if(headerObject[L12].customHeader.length > 0){
                        dcSubjectHeader = headerObject[L12].customHeader
                    }
			 for (var L10a = 0; L10a < concatDcShdrs.length; L10a++){    
				   for (var L10b = 0; L10b < headerObject.length; L10b++){         
					if(headerObject[L10b].header == concatDcShdrs[L10a]){  
						if(headerObject[L10b].customHeader.length > 0){
							concatDcSindx.push(textFileHeaders.indexOf(headerObject[L10b].customHeader))
						   //  concatDcSindx[L10a] = textFileHeaders.indexOf(headerObject[L10b].customHeader)
							 //      concat1 = textFileHeaders.indexOf(headerObject[L10b].customHeader)
								}       
								else{
								concatDcSindx[L10a] = L10b
								}
							}
						}
					var concat1 = concatDcSindx[0]
					var concat2 = concatDcSindx[1]
					var concat3 = concatDcSindx[2]
					var concat4 = concatDcSindx[3]
					var concat5 = concatDcSindx[4]
				 }			
                }            
            // else use default header and path
            else{
                    dcSubjectHeader = headerObject[L12].header
                    var concat1 = textFileHeaders.indexOf("Work Subject")
                    var concat2 = textFileHeaders.indexOf("Work Style/Period")
                    var concat3 = textFileHeaders.indexOf("Work Culture")
                    var concat4 = textFileHeaders.indexOf("Work Work Type")
                    var concat5 = textFileHeaders.indexOf("Work Techniques")
                }
            // run the import
            if(dcSubjectHeader.length > 0){
                var index = textFileHeaders.indexOf(dcSubjectHeader)
                var prop = textFileValue[index].split ('"').join ('').split ('; ').join(';').split (';');
                var count = xmpData.countArrayItems (XMPConst.NS_DC, 'subject');         
                var createKeywordsArray  = [textFileValue[concat1], textFileValue[concat2], textFileValue[concat3], textFileValue[concat4], textFileValue[concat5]];              
                keywordsString = "X"
                keywords = []
                for(var L1 = 0; L1<createKeywordsArray.length; L1++){
                            if(createKeywordsArray[L1]){
                             keywordsString = keywordsString+"; "+createKeywordsArray[L1].toString() ;
                            }                          
                         } 	 
                keywords = keywordsString.split ('"').join ('').split('X; ').join('').split("; ")	 	
                 if(index > 0){	
                        if (writeOptions.overwriteRb.value == true){
                            xmpData.deleteProperty(XMPConst.NS_DC, 'subject'); 
                             if (textFileValue[index].length > 0 || keywords.length > 0){
                                xmpData.setProperty (XMPConst.NS_DC, 'subject', "", XMPConst.ARRAY_IS_UNORDERED);
                                if (fillSubjCb.value == true){
                                    for (var L1 = 0; L1 < keywords.length; L1++)
                                    xmpData.setProperty (XMPConst.NS_DC, 'subject' + '[' + (L1+1) + ']', keywords[L1]);		
                                }
                                else{	
                                    for (var L1 = 1; L1 < (prop.length + 1); L1++)
                                    xmpData.setProperty (XMPConst.NS_DC, 'subject' + '[' + L1 + ']', prop[L1 - 1]);
                                }
                            }
                        }
                        else if (count == 0 && textFileValue[index].length > 0 || count == 0 && keywords.length > 0){
                           xmpData.setProperty (XMPConst.NS_DC, 'subject', "", XMPConst.ARRAY_IS_UNORDERED);
                           if (fillSubjCb.value == true){
                                for (var L1 = 0; L1 < keywords.length; L1++)
                                  xmpData.setProperty (XMPConst.NS_DC, 'subject' + '[' + (L1+1) + ']', keywords[L1]);												
                            }                                       
                            else{	
                                for (var L1 = 1; L1 < (prop.length + 1); L1++)
                                xmpData.setProperty (XMPConst.NS_DC, 'subject' + '[' + L1 + ']', prop[L1 - 1]);
                            }
                        }		
                    propPass.push(dcSubjectHeader)
                } // close if(dcSubjectHeader.length > 0){
            }
            } // close try
            catch(propFail){propFail++, propFailName.push(path)}
            } // close if(headerObject[L10].type == 'langAltDcDescription'){
        } // close import Summary Keywords
			
         // import copyright status	
                for (var L13 = 0; L13 < headerObject.length; L13++){    
                    var statusHeader = "";
                    if(headerObject[L13].header == "Image Copyright Status"){
                        try{
                            // if customHeader length > 0, use it and path  
                            if (buttonsChoice.customHeadersRb.value == true){
                                if(headerObject[L13].customHeader.length > 0){
                                    statusHeader = headerObject[L13].customHeader                                
                                    }                              
                                }            
                            // else use default header and path
                            else{
                                statusHeader = headerObject[L13].header
                                }		
                            // run the import
                            if(statusHeader.length > 0){	// add else with alert 'No matching headers fo  
								var index = textFileHeaders.indexOf(statusHeader)
							var prop = xmpData.getProperty(headerObject[L13].namespace, headerObject[L13].path);  
							var Prop =   textFileValue[index].toLowerCase().replace(/\b[a-z]/g, cnvrt);
							if(Prop == "Copyrighted"){Prop = "True";}
							if(Prop == "Public domain"){Prop = "False";}
							function cnvrt(){
								return arguments[0].toUpperCase();
								} 
                                var index = textFileHeaders.indexOf(statusHeader)		
                               if(index > 0){         
                                if (writeOptions.overwriteRb.value == true){
                                    xmpData.deleteProperty(headerObject[L13].namespace, headerObject[L13].path);                   
                                    if (textFileValue[index].length > 0){
                                      if (Prop == "True" || Prop == "False"){                                
									xmpData.setProperty (XMPConst.NS_XMP_RIGHTS, "Marked", Prop, XMPConst.BOOLEAN);
									}
                                        }
                                    }
                                else if (Prop == undefined && textFileValue[index].length > 0){
                                    if (Prop == "True" || Prop == "False"){                                
									xmpData.setProperty (XMPConst.NS_XMP_RIGHTS, "Marked", Prop, XMPConst.BOOLEAN);
									}
                                    } 
								propPass.push(statusHeader)
								} // close if(textHeader.length > 0)
							}        
                             } // close try
                            catch(propFail){propFail++, propFailName.push(path)}
                        }	// end if(headerObject[L13].header == "Image Copyright Status")
                    } // close import copyright status	
				                            
                     // Set white label to indicate data was imported
                    var prop = xmpData.getProperty (XMPConst.NS_XMP, "Label");
                    try{
                        if (addLabelCb.value == true){
                            xmpData.setProperty (XMPConst.NS_XMP, "Label", "VRA metadata imported");	 		
                            }
                       }
                          catch(propFail){propFail++, propFailName.push(path)}
                    // if any property failed to import, add the filename to the fileFailArr so it can be reported at the end
                    if(propPass.length == 0){
                       fileFailArr.push(allFiles[L3]);
                        }
                    else{
                        filePass++;
                        }
            // Write save file and close	
            try{
                // todo - write .xmp differently
                // if file is an .xmp sidecar - read the xmp directly to an XMPMeta Object
                if(imageFile.name.match(/\.xmp/i) != null){
                xmpFile.open('w'); 
                xmpFile.close()
                xmpFile.open('w')
                xmpFile.write(xmpData.serialize(XMPConst.SERIALIZE_OMIT_PACKET_WRAPPER));
                xmpFile.close()
                    }
                else{     
                    if (xmpFile.canPutXMP(xmpData)) {
                        xmpFile.putXMP(xmpData);
                        }
                    xmpFile.closeFile(XMPConst.CLOSE_UPDATE_SAFELY);	
                    }
                }
            catch(couldNotCloseError){couldNotClose.push(allFiles[L3])}             
                    }		
                } // close the loop: for (var L4 = 1; L4 < textFile.length; L4++)   
            } // also tried on line 1392
		catch(couldNotOpenError){couldNotOpen.push(imageFile.fsName)}    
               } // close the loop: if (allFiles[L3])	
             } // close the loop: for (var L3 = 0; L3 < allFiles.length; L3++) 

		    // hide the progress bar
            importingProgress.hide();    
			var failMasg = ""
			// set fail message vale
			if(customHeadersImported.length==0){
				   failMesg = "The Custom Field Names option was selected,\nbut none were found.\n\nCheck your import file or select the Default Field Names option"
				   }
			else{
				failMesg = "No matching files were found.\n\nFiles are matched by file name.\n\nMake sure the folder you have selected contains the image file names in yout metadata text file."
				}			   
			// Show results of Import
			  if (filePass == 0){
				   app.beep()
					   Window.alert(failMesg)
                }
			else{     
                    // Show report that import is complete
                    var complete = new Window("dialog", "Import Complete"); 
                //    complete.preferredSize = [400,400];
                    complete.spacing = 3;
                    complete.alignChildren = 'center';
                    complete.header = complete.add('statictext', undefined, "Success!");
                    complete.header.preferredSize = [400,40];
                    complete.header .justify = 'center';
                    complete.msg1= complete.add('statictext', undefined, "Data has been successfully imported for " + filePass + " files.", {multiline:true});
// \nThese fields were imported:\n\n"+propPass.join("\n")
                  //  complete.msg1.preferredSize = [400,60];
					complete.msg1.alignment = 'fill','fill'
                     complete.msg1.justify = 'center';                
                     complete.msg3 = complete.add('statictext', undefined, "These fields were imported:", {multiline:true}); // The Custom Field Names option was selected.\n
                     complete.msg3.preferredSize = preferredSize = [400, 40];
                     complete.msg3.justify = 'center';     
                     complete.msg4 = complete.add('edittext', undefined, propPass.join("\n"), {multiline:true});
                     complete.msg4.preferredSize = preferredSize = [250, 200];
                     complete.msg4.justify = 'left';     	
               /*     if(setHeaders.text == "Using Custom Field Names"){
                        complete.msg3.minimumSize = [400, 40];
                        complete.msg3.maximumSize = [400, 40];
                        complete.msg4.minimumSize = [250, 400];
                        complete.msg4.maximumSize = [250, 400];
                        }*/
                    // List of files that could not be opened to write metadata
                    complete.problem1 = complete.add('group');
                    complete.problem1.orientation = 'column';	
                    complete.problem1.maximumSize = [0,0];
                    complete.problem1.header = complete.problem1.add('statictext', undefined, "But...");
                    complete.problem1.header.graphics.font = ScriptUI.newFont ('Arial', 'BOLD', 16);
                    complete.problem1.msg1 = complete.problem1.add('statictext', undefined, "These files could not be opened for import.\nThey might be corrupted or have an incompatable data structure.");
                    complete.problem1.list = complete.problem1.add ('edittext', [0, 0, 500, 150], couldNotOpen.join("\n"), {multiline:true});

				// If there are files that couln't be opened, make problem1 visible		
                    if (fileFailArr.length > 0){
					complete.problem1.maximumSize = [500,400];
					}
                    complete.okBtn = complete.add('button', undefined, 'Close');
                    complete.okBtn.onClick =  function(){ 
					complete.hide();
					}
                complete.show();		
			}
        }  
    } // close 'function importFromFile(){'
	} // close 'if(exportWhich.thumbsRb.value == true && app.document.selections.length == 0)'	
  ///////////////////////////////////////////////
 ////////// END IMPORT //////////
///////////////////////////////////////////////
	} // brace 2 close 'if( xmpLib == undefined ){'
}  // brace 1 close entire script - starting at : //Create a menu option within Adobe Bridge


